 /* TFTDExtender - Mod for X-COM: Terror from the Deep
 * NOTE: This project is unfinished. Some of the code is obsolete, useless, or detrimental. Use at your own risk.
 * Original UFO Extender is copyright (C) 2008-2010 Seb76. Initial conversion for X-COM: Terror from the Deep was implemented by Xusilak.
 * Further conversion and updates by <Morgan525/Tycho>.
 * TFTD Patcher is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

 * TFTD Patcher is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along with TFTD Patcher.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "base.h"
#include "xcom.h"
#include "patcher.h"

//Handles mouse clicks on the decrement button in the manufacture quantity dialog window.
__declspec(naked) void handleDecrementProductionNumber()
{
	__asm pusha

	static int ECXvalue, ESIvalue;
	static short mouseY;
	static short* pdesiredNum;

	__asm
	{
		//ECX and ESI store the components to the pointer to the desired production quantity.
		mov	ECXvalue, ecx
		mov	ESIvalue, esi
		
		//Get the mouse's vertical position.
		mov	mouseY, di
	}
	
	//mouseY = *mouse_ypos;

	//Get the pointer to the desired number.
	pdesiredNum = (short*)(ECXvalue + ESIvalue*2 + 0x102);

	//Check that the mouse's position is over the right button.
	if(mouseY >= 0x83 && mouseY <= 0x91)
	{
		if((*pdesiredNum) > -2)
		{
			(*pdesiredNum)--;

			//Set the flags that indicate the button was just freshly pressed
			//(Base pointer 3Ch) - (Stack offset xxh) - (Return address 4h) - (pusha 10h)
			//__asm mov [esp + 3Ch - 2Ch + 4h + 10h], 1
			//__asm mov [esp + 3Ch - 28h + 4h + 10h], 1
			//__asm mov [esp + 3Ch - 14h + 4h + 10h], 1
			__asm mov [esp + 3Ch - 2Ch + 14h], 1
			__asm mov [esp + 3Ch - 28h + 14h], 1
			__asm mov [esp + 3Ch - 14h + 14h], 1
		}
	}

	__asm
	{
		popa
		push	esi
		push	ecx
		mov		ecx, ECXvalue
		mov		esi, ESIvalue
		mov		ax, [ecx+esi*2+0x102]
		pop		ecx
		pop		esi
		retn
	}
}

//This function removes the check to stop production on items with -1 and -2 desired quantities set.
__declspec(naked) void jumpToProductionCompleteHandler()
{
	__asm pusha

	static short baseNum, producedNum, desiredNum, itemProductType, itemBaseType, itemPurchaseType = -1;
	static int productSellPrice;

	//Load all the values we'll need into C variables.
	__asm
	{
		mov cx, [ebp - 56h]
		mov desiredNum, cx

		mov cx, [esp + 44h - 2Ch + 4h + 10h]
		mov itemProductType, cx

		mov cx, [ebp + 0]
		mov producedNum, cx

		mov cx, [esp + 44h - 34h + 4h + 10h]
		mov baseNum, cx
	}

	//We must translate from the item product type to the item purchase type.
	itemBaseType = *(ProductDat + 14 + 18*itemProductType); //Translate from product.dat type to base.dat type
	
	//Because there's no way to directly index from a base.dat item type (to my knowledge), we need to reverse-index it
	//by iterating through purchase.dat and looking for our base.dat item type. Yes, this is slow.
	for(int i = 8; i < 99; i++)
	{
		if(*((char*)(PurchaseDat) + 1 + i * 20) == itemBaseType)
		{
			itemPurchaseType = i;

			break;
		}
	}
	if(itemPurchaseType <= -1)
	{
		//Error condition; this should never happen unless bad data is being used.
		itemPurchaseType = 0;	//Just set it to a soldier for now, since they have no sell value.
	}

	//Grab the sell price from PurchaseDat.
	productSellPrice = *((int*)((char*)(PurchaseDat) + 10 + (int)(itemPurchaseType) * 20));

	//Handle the actual production details.
	if((desiredNum > -1) && (producedNum >= desiredNum))
	{	//Stop production; we've made enough.
		__asm 
		{
			popa
			add esp, 4

			push 4456BEh //was 44188Eh

			ret
		}
	}
	else if(desiredNum == -1)
	{	//-1 means we don't want to stop production, and we want to sell the results.
		*money += productSellPrice;
		(*(int*)(((char*)(*BaseDat)) + ((char)baseNum) * 296 + 16 + (int)(itemBaseType)*2)) -= 1;
		__asm
		{
			popa
			retn
		}
	}
	else if(desiredNum <= -2)
	{	//-2 means we want an infinitely produced item, but we don't want to sell it.
		//This code is superfluous, as the 'else' below would handle it, but it is added for clarity.
		__asm
		{
			popa
			retn
		}
	}
	else
	{	//Do nothing, because we're not done producing yet.
		__asm
		{
			popa		
			retn
		}
	}
}

//Replace the -1 and -2 values in the manufacture quantity dialog window with $$$ and ***.
__declspec(naked) void drawNewManufactureQuantityDialogLabel()
{
	static int desiredNum, color, *dst, offsetX, offsetY;
	static short useSmallFont;

	__asm
	{
		//Get the arguments for the call.
		push edx
		mov edx, [esp + 04h + 04h]
		mov desiredNum, edx

		mov edx, [esp + 04h + 08h]
		mov color, edx

		mov edx, [esp + 04h + 0Ch]
		mov dst, edx
		pop edx

		pusha
		push esi
	}

	useSmallFont = 0;

	offsetY = int(((char*)dst - *BackBuffer) / 320);
	offsetX = ((char*)dst - *BackBuffer) % 320;

	//Draw the appropriate numbers or symbols.
	if(desiredNum > -1)
	{
		DrawNumber2(desiredNum, color, offsetY, offsetX + 7, useSmallFont);
	}
	else if(desiredNum == -1)
	{
		DrawString("$$$", color, offsetY, offsetX + 7, useSmallFont);
	}
	else
	{
		DrawString("***", color, offsetY, offsetX + 7, useSmallFont);
	}

	__asm
	{
		pop esi
		popa
		retn
	}
}

//Replace the -1 and -2 quantity values with $$$ and *** on the main manufacturing screen.
__declspec(naked) void drawNewMainManufactureQuantityLabel()
{
	static int desiredNum, color, useSmallFonts;
	static short ypos, xpos;

	__asm
	{
		//Get the arguments for the call.
		push edx
		mov edx, [esp + 04h + 04h]
		mov desiredNum, edx
		mov edx, [esp + 04h + 08h]
		mov color, edx
		mov dx, [esp + 04h + 0Ch]
		mov ypos, dx
		mov dx, [esp + 04h + 10h]
		mov xpos, dx
		mov edx, [esp + 04h + 14h]
		mov useSmallFonts, edx
		pop edx

		pusha
		push esi
		push edi
	}

	//Draw the appropriate numbers or symbols.
	if(desiredNum > -1)
	{
		DrawNumber2(desiredNum, color, ypos, xpos, useSmallFonts);
	}
	if(desiredNum == -1)
	{
		DrawString("$unlimited$", color, ypos, xpos-40, useSmallFonts);
	}
	if(desiredNum < -1)
	{
		DrawString("unlimited", color, ypos, xpos-25, useSmallFonts);
	}

	__asm
	{
		pop edi
		pop esi
		popa

		retn
	}
}
void drawNewManufactureDialogEntry()
{
unsigned short xpos, ypos, hours;
unsigned int days;
 
__asm
	{
	mov	xpos, ax
	mov	ypos, cx
	mov	days, edi
	mov	hours, si
	}	

if (days<366)
	{
	DrawNumber2(days,0xF5,ypos,xpos,1);
	DrawString("/",0xF5,(*carretPosition),0xFFFF,1);
	DrawNumber(hours, 0xF5,(*carretPosition),1);
	}
else if (days>365)
	{	
	DrawString("indefinite",0xF5,ypos,xpos-6,1);
	}
}
