 /* TFTDExtender - Mod for X-COM: Terror from the Deep
 * NOTE: This project is unfinished. Some of the code is obsolete, useless, or detrimental. Use at your own risk.
 * Original UFO Extender is copyright (C) 2008-2010 Seb76. Initial conversion for X-COM: Terror from the Deep was implemented by Xusilak.
 * Further conversion and updates by <Morgan525/Tycho>.
 * TFTD Patcher is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

 * TFTD Patcher is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along with TFTD Patcher.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "xcom.h"
#include "patcher.h"

#define EQUIP_FILE "./missdat/equip.ini"

#define EQUIP_READ_INT(soldier,key,default) GetPrivateProfileIntA(soldier,key,default,EQUIP_FILE)

int auto_flares = 0;
static unsigned char slot_order[]= {7,6,9,8,2,3,4,5,19,20,21,22,23,24,10,11,12,13,14,15,16,17,18,0,1};

unsigned char soldier_data[17500];

typedef struct
{
	unsigned char item;
	unsigned char itemType;
	unsigned char clip; // in case there is something loaded into the item
	unsigned char clipType;
} slot_t;

int IsXComItem(unsigned char item)
{
	return pObpos_dat[item].flags&1;
}

slot_t *GetItemSlot(unsigned char item, slot_t *slots)
{
	for(int i=0;i<25;i++)
	{
		if(slots[i].item == item)
			return &slots[i];
	}
	return NULL;
}

void FindSlots(unsigned char unitpos, slot_t *slots)
{
	memset(slots,0xff,25*sizeof(slot_t));
	
	obpos_dat *pObPos=pObpos_dat;

	//add items to slots
	for(unsigned char i=0;i<200;i++)
	{
		if(pObPos->itemType != 0xff && pObPos->owner == unitpos && pObPos->container == 0xffff)
		{
			unsigned char slot = pObPos->slot;
			slots[slot].item = i;
			slots[slot].itemType = pObPos->itemType;
		}
		pObPos++;
	}
	
	pObPos=pObpos_dat;

	//add items loaded into slot items
	for(unsigned char i=0;i<200;i++)
	{
		if(pObPos->itemType != 0xff && pObPos->owner == unitpos && pObPos->container != 0xffff)
		{
			slot_t *slot=GetItemSlot((unsigned char)pObPos->container,slots);
			if(slot!=NULL)
			{
				slot->clip = i;
				slot->clipType = pObPos->itemType;
			}
		}
		pObPos++;
	}

}
/*
void AddClipWeight(unsigned char unitpos)
{
	slot_t slots[25];
	memset(slots,0xff,sizeof(slots));
	
	obpos_dat *pObPos=pObpos_dat;

	//add items to slots
	for(unsigned char i=0;i<200;i++)
	{
		if(pObPos->itemType != 0xff && pObPos->owner == unitpos && pObPos->container == 0xffff)
		{
			unsigned char slot = pObPos->slot;
			slots[slot].item = i;
		}
		pObPos++;
	}
	
	pObPos=pObpos_dat;

	//assign items loaded into slot items to the soldier
	for(unsigned char i=0;i<200;i++)
	{
		if(pObPos->itemType != 0xff && pObPos->container != 0xffff )
		{
			slot_t *slot=GetItemSlot((unsigned char)pObPos->container,slots);
			if(slot!=NULL)
			{
				pObPos->owner=unitpos;
			}
		}
		pObPos++;
	}

}

void FixClipWeight()
{
	unsigned char *unitpos = (unsigned char *)unitpos_dat;
	
	for(unsigned char i=0;i<80;i++)
	{
		if(unitpos[0] != 0xff)
		{
			unitref_dat *unitref=*(unitref_dat **)&(unitpos)[4];

			if(unitref->Unit_Type<3)
			{
				AddClipWeight(i);
			}
		}
		unitpos+=14;
	}

}
*/

unsigned char GetFreeItem(unsigned char itemType)
{
	obpos_dat *pObPos=pObpos_dat;

	for(unsigned char i=0;i<200;i++)
	{
		if(pObPos->itemType == itemType && pObPos->owner == 0xff && pObPos->container == 0xffff && IsXComItem(i))
		{
			return i;
		}

		pObPos++;
	}
	return 0xff;
}
/*
void UnloadClips()
{
	obpos_dat *pObPos=pObpos_dat;

	for(unsigned char i=0;i<200;i++)
	{
		if(pObPos->itemType != 0xff && pObPos->container != 0xffff  && IsXComItem(i))
		{
			pObPos->container=0xffff;
		}
		pObPos++;
	}
}
*/
unsigned char GetAmmoForWeapon(unsigned char gunType)
{
	obpos_dat *pObPos=pObpos_dat;

	unsigned char *pObdata = &(*file_geodata_obdata_dat)[54*gunType];

	unsigned char *ammos = &pObdata[26];

	for(int i=0;i<3;i++)
	{
		unsigned char ammo = GetFreeItem(ammos[i]);
		if( ammo != 0xff)
		{
			return ammo;
		}
	}

	return 0xff;
}

unsigned char GetNumAmmoForWeapon(unsigned char gunType)
{
	obpos_dat *pObPos=pObpos_dat;

	unsigned char *pObdata = &(*file_geodata_obdata_dat)[54*gunType];

	unsigned char *ammos = &pObdata[26];
	unsigned char ret = 0;

	for(int i=0;i<3;i++)
	{
		obpos_dat *pObPos=pObpos_dat;

		for(int j=0;j<170;j++)
		{
			if(pObPos->itemType == ammos[i] && pObPos->owner == 0xff && pObPos->container == 0xffff && IsXComItem(j))
			{
				ret++;
			}

			pObPos++;
		}
	}

	return ret;
}

unsigned char GetGrenade()
{
	unsigned char grenade = GetFreeItem(44); // alien grenade
	if(grenade!=0xff)
	{
		return grenade;
	}
	grenade = GetFreeItem(22); // HE
	if(grenade!=0xff)
		return grenade;

	grenade = GetFreeItem(19); // 'nade
	if(grenade!=0xff)
		return grenade;

	return GetFreeItem(21); // proxmine
}

void AssignWeapon(unsigned char unitpos, unitref_dat* unitref, unsigned char gunType, unsigned char clips)
{
	unsigned char gun = GetFreeItem(gunType);
	pObpos_dat[gun].owner = unitpos;
	pObpos_dat[gun].slot = 0;
	unitref->R_Hand_Item = gunType;

	unsigned char clip = GetAmmoForWeapon(gunType);
	if(clip != 0xff)
	{
		pObpos_dat[clip].owner = unitpos;
		pObpos_dat[clip].container = gun;
	}

	unsigned char slots_vert[] = {10,11,12,19,22};
	unsigned char slots_hori[] = {10,13,16,20};
	unsigned char *slots=slots_vert;

	if(gunType == 4 || gunType == 8)
	{
		slots=slots_hori;
	}

	for(unsigned char i=0;i<clips-1;i++)
	{
		unsigned char clip2 = GetAmmoForWeapon(gunType);
		if(clip2 != 0xff)
		{
			pObpos_dat[clip2].owner = unitpos;
			pObpos_dat[clip2].slot = slots[i];
		}
	}
}

void AssignAvailableWeapon(unsigned char unitpos, unitref_dat* unitref)
{
	obpos_dat *pObPos=pObpos_dat;

	for(unsigned char i=0;i<200;i++)
	{
		if(pObPos->itemType != 0xff && pObPos->owner == 0xff && pObPos->container == 0xffff && IsXComItem(i))
		{
			switch(pObPos->itemType)
			{
			case 0: //Dart Pistol
			case 2: //Jet Harpoon
			case 8: //hydro-jet cannon
			case 16: //Gauss pistol
			case 17: //Gauss rifle
				{
					unsigned char clips = GetNumAmmoForWeapon(pObPos->itemType);
					if(clips>1)
					{
						AssignWeapon(unitpos, unitref, pObPos->itemType, 2);
						return;
					}

					break;
				}
			case 18: //Heavy gauss
			case 34: //Sonic Cannon
			case 36: //Sonic Blasta rifle
			case 38: //Sonic pistol
				//2 clips is enough
				{
					unsigned char clips = GetNumAmmoForWeapon(pObPos->itemType);
					if(clips>1)
					{
						AssignWeapon(unitpos, unitref, pObPos->itemType, 2);
						return;
					}

					break;
				}
			case 12: //rocket launcher
				//4 clips
				{
					unsigned char clips = GetNumAmmoForWeapon(pObPos->itemType);
					if(clips>3)
					{
						AssignWeapon(unitpos, unitref, pObPos->itemType, 4);
						return;
					}

					break;
				}
			case 40: //blaster launcher
				//4 clips
				{
					unsigned char clips = GetNumAmmoForWeapon(pObPos->itemType);
					if(clips>3)
					{
						AssignWeapon(unitpos, unitref, pObPos->itemType, 4);
						return;
					}

					break;
				}
			case 4: //gas cannon
			case 42: //thermal shock launcher
			//5 extra
				{
					unsigned char clips = GetNumAmmoForWeapon(pObPos->itemType);
					if(clips>4)
					{
						AssignWeapon(unitpos, unitref, pObPos->itemType, 5);
						return;
					}

					break;
				}
			AssignWeapon(unitpos, unitref, pObPos->itemType, 0);
				return;
			default:
				break;
			}
		}
		pObPos++;
	}
}

void ReloadUnassignedGuns()
{
	obpos_dat *pObPos=pObpos_dat;

	for(unsigned char i=0;i<200;i++)
	{
		if(pObPos->itemType != 0xff && pObPos->owner == 0xff && IsXComItem(i))
		{
			unsigned char ammo = GetAmmoForWeapon(pObPos->itemType);
			if(ammo != 0xff)
			{
				pObpos_dat[ammo].container = i;
			}
		}
		pObPos++;
	}
}
/*
void StripEquiment(unsigned char unitpos)
{
	slot_t slots[25];
	memset(slots,0xff,sizeof(slots));
	
	obpos_dat *pObPos=pObpos_dat;

	for(unsigned char i=0;i<210;i++)
	{
		if(pObPos->itemType != 0xff && pObPos->owner == unitpos && pObPos->container == 0xffff && IsXComItem(i))
		{
			unsigned char slot = pObPos->slot;
			slots[slot].item = i;
			pObPos->owner = 0xff;
		}
		pObPos++;
	}
	
	pObPos=pObpos_dat;

	//unassign items loaded into slot items
	for(unsigned char i=0;i<200;i++)
	{
		if(pObPos->itemType != 0xff && pObPos->container != 0xffff && IsXComItem(i))
		{
			slot_t *slot=GetItemSlot((unsigned char)pObPos->container,slots);
			if(slot!=NULL)
			{
				pObPos->owner=0xff;
				pObPos->container=0xffff;
			}
		}
		pObPos++;
	}

}
void UnequipSoldiers()
{
	unsigned char *unitpos = (unsigned char *)unitpos_dat;
	
	for(unsigned char i=0;i<80;i++)
	{
		if(unitpos[0] != 0xff)
		{
			unitref_dat *unitref=*(unitref_dat **)&(unitpos)[4];

			if(unitref->Unit_Type<3)
			{
				StripEquiment(i);
				unitref->L_Hand_Item=0xff;
				unitref->R_Hand_Item=0xff;
			}
		}
		unitpos+=14;
	}
}
*/
void GetSoldierUUID(unitref_dat *unitref, char *dst)
{
	unsigned char *s=soldier_data+70*unitref->soldier_index;
	
	sprintf(dst,"%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X",s[26],s[27],s[28],s[29],s[33],s[34],s[64],s[67],s[68],s[69]);
}

int LoadSoldierEquipment(unsigned char unitpos, unitref_dat *unitref)
{
	int equiped = 0;
	char soldierID[32];
	GetSoldierUUID(unitref, soldierID);

	for(int i=0;i<25;i++)
	{
		char slot[8];
		char clip[8];
		sprintf(slot,"slot%d",i);
		sprintf(clip,"clip%d",i);

		unsigned char item_type=EQUIP_READ_INT(soldierID,slot,0xff);
		unsigned char item_clip=EQUIP_READ_INT(soldierID,clip,0xff);

		if(item_type != 0xff)
		{
			unsigned char it = GetFreeItem(item_type);
			if(it != 0xff)
			{
				equiped = 1;
				int use_weapon = 1;
				if(item_clip != 0xff)
				{
					unsigned char clip=GetFreeItem(item_clip);
					if(clip == 0xff)
						clip = GetAmmoForWeapon(item_type);
					if(clip != 0xff)
					{
						pObpos_dat[clip].owner = unitpos;
						pObpos_dat[clip].container = it;
					}
					else
					{
						use_weapon = 0;
					}
				}

				if(use_weapon)
				{
					pObpos_dat[it].owner = unitpos;
					pObpos_dat[it].slot = i;

					if(i == 0)
						unitref->R_Hand_Item = item_type;
					if(i == 1)
						unitref->L_Hand_Item = item_type;
				}
			}
		}
	}
	return equiped;
}

void ReloadEquipment()
{
	int auto_equiped[80];
	memset(auto_equiped,0,sizeof(auto_equiped));
	unsigned char *unitpos = (unsigned char *)unitpos_dat;
	
	for(unsigned char i=0;i<80;i++)
	{
		if(unitpos[0] == 0xff)
			continue;

		unitref_dat *unitref=*(unitref_dat **)&(unitpos)[4];

		if(unitref->Unit_Type<3)
		{
			auto_equiped[i] = LoadSoldierEquipment(i,unitref);
		}
		unitpos+=14;
	}

	unitpos = (unsigned char *)unitpos_dat;
	for(unsigned char i=0;i<80;i++)
	{
		unitref_dat *unitref=*(unitref_dat **)&(unitpos)[4];

		if(unitpos[0] != 0xff && !auto_equiped[i] && unitref->Unit_Type<3)
		{
			AssignAvailableWeapon(i,unitref);

			unsigned char grenade = GetGrenade();
			if(grenade!=0xff)
			{
				pObpos_dat[grenade].owner = i;
				pObpos_dat[grenade].slot = 4;
			}
		}
		unitpos+=14;
	}
}

void EquipFlares()
{
	unsigned char *unitpos = (unsigned char *)unitpos_dat;
	
	for(unsigned char i=0;i<80;i++)
	{
		if(unitpos[0] == 0xff)
			continue;

		slot_t slots[25];
		FindSlots(i,slots);

		unitref_dat *unitref=*(unitref_dat **)&(unitpos)[4];

		if(unitref->Unit_Type<3)
		{
			unsigned char flare = GetFreeItem(0x1b);
			unsigned char slot = 0xff;
			
			unsigned char test[6]={4,2,6,8,19,10};
			for(int j=0;j<6;j++)
			{
				if(slots[test[j]].itemType == 0xff)
				{
					slot = test[j];
					break;
				}
			}

			if(flare != 0xff && slot != 0xff)
			{
				pObpos_dat[flare].owner = i;
				pObpos_dat[flare].slot = slot;
			}
		}
		unitpos+=14;
	}
}

void SetItemsOnGround()
{
	

	for(unsigned char i=0;i<=210;i++)
	{
		int ObPosDat=0x4D85E0+(i*16);
		if(*(unsigned char*)ObPosDat!=0xFF && *(unsigned char*)(ObPosDat+4)==0xFF)
		{
			unsigned char ypos=*(char *)(ObPosDat+1);
			unsigned char xpos=*(char *)(ObPosDat+2);
			unsigned char zpos=*(char *)(ObPosDat+3);
			unsigned char MCDtileHigh=GetTileHeight(ypos,xpos,zpos);
			*(unsigned char *)(ObPosDat+11)=MCDtileHigh;
		}
	}
}

void SaveEquipmentLayout()
{
	unsigned char *unitpos = (unsigned char *)unitpos_dat;
	
	for(unsigned char i=0;i<80;i++)
	{
		if(unitpos[0] == 0xff)
			continue;

		unitref_dat *unitref=*(unitref_dat **)&(unitpos)[4];

		if(unitref->Unit_Type<3)
		{
			char soldierID[32];
			GetSoldierUUID(unitref, soldierID);

			WritePrivateProfileStringA(soldierID, "Name", unitref->Name, EQUIP_FILE);

			slot_t slots[25];
			FindSlots(i,slots);
			for(int s=0;s<25;s++)
			{
				char slot[8];
				char clip[8];
				char slot_item[8];
				char clip_item[8];
				sprintf(slot,"slot%d",s);
				sprintf(clip,"clip%d",s);
				sprintf(slot_item,"%d",slots[s].itemType);
				sprintf(clip_item,"%d",slots[s].clipType);

				if(slots[s].itemType!=0xff && !(auto_flares && slots[s].itemType == 0x1b))
					WritePrivateProfileStringA(soldierID,slot,slot_item,EQUIP_FILE);
				else
					WritePrivateProfileStringA(soldierID,slot,NULL,EQUIP_FILE);

				if(slots[s].clipType!=0xff)
					WritePrivateProfileStringA(soldierID,clip,clip_item,EQUIP_FILE);
				else
					WritePrivateProfileStringA(soldierID,clip,NULL,EQUIP_FILE);
			}
		}

		unitpos+=14;
	}
}

void SaveEquipment()
{
	//Force reloading of the ini file
	WritePrivateProfileStringA(NULL, NULL, NULL, EQUIP_FILE);
	int fd = open("./MISSDAT/soldier.dat",O_RDONLY|O_BINARY);
	if(fd != -1)
	{
		int len = read(fd, soldier_data, 17500);
		if(len == 17500)
		{
			ReloadEquipment();
			ReloadUnassignedGuns();
			if(auto_flares && *tac_ambient_light>=8)
			{	
				EquipFlares();
			}
		close(fd);
		}
	}
	SetItemsOnGround();
}

void DeleteIniFile()
{
	DeleteFileA(EQUIP_FILE);
}

void InitNewGeoGameHook()
{
	InitNewGeoGame();
	DeleteIniFile();
}

void SaveTacticalGameHook(char *slot)
{
	char path[MAX_PATH];
	sprintf(path,"./%s/equip.ini",slot);
	CopyFileA("./MISSDAT/equip.ini",path,FALSE);

	SaveTacticalData(slot);
}

void SaveGeoGameHook(char *slot)
{
	char path[MAX_PATH];
	sprintf(path,"./%s/equip.ini",slot);
	CopyFileA("./MISSDAT/equip.ini",path,FALSE);

	SaveGeoGameData(slot);
}

void LoadGameHook(char *slot)
{
	char path[MAX_PATH];
	sprintf(path,"./%s/equip.ini",slot);
	CopyFileA(path, "./MISSDAT/equip.ini",FALSE);

	LoadGeographGame(slot);
}
