 /* TFTDExtender - Mod for X-COM: Terror from the Deep
 * NOTE: This project is unfinished. Some of the code is obsolete, useless, or detrimental. Use at your own risk.
 * Original UFO Extender is copyright (C) 2008-2010 Seb76. Initial conversion for X-COM: Terror from the Deep was implemented by Xusilak.
 * Further conversion and updates by <Morgan525/Tycho> with extreme appreciation to Kyrub for his work as well.
 * TFTD Patcher is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

 * TFTD Patcher is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along with TFTD Patcher.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "patcher.h"
#include "patches.h"
#include "xcom.h"
#include "resource.h"
#include "hacks.h"
#include "base.h"
#include "music.h"
#include "tacticalai.h"
#include "stun.h"
#include "video.h"
#include "interception.h"
#include "acc.h"
#include "obdata.h"


extern void ClickPauseBug();
extern void ShowTacOptionScreen();
/*
 * TODO:
 *  -ammo weight bug in inventory
 *  -base defense reset retaliation flag
 *  -psi attacks target random soldier
 *  -mind controlled soldiers at the end become MIA
 *  -more realistic grenade fuse
 * *  -80 items limit??
 */

const int PatchAddr_geoDrawDateTimePanel4 = 0x4633F4;
const int PatchAddr_geoDrawDateTimePanel3 = 0x46336A;
const int PatchAddr_geoDrawDateTimePanel2 = 0x444D1A;
const int PatchAddr_geoDrawDateTimePanel1 = 0x4445AC;

void LockCursor();

/*
 * Make visible the presence of the loader
 */
void ShowLoader()
{
	//DrawString("Ia! Ia! Cthulhu Fthagn!",0x9,0x06,0x6F,1);
	DrawString("TFTD Extender @ www.ufopaedia.org ",0x9,0xB8,0x4C,1);
	((void (*)(int))(0x432D30))(1);
}

void ShowMod()
{
	DrawString("Ia! Ia! Cthulhu Fthagn!",0x9,0xB8,0x6F,1);
	((void (*)(int))(0x432D30))(1);
}

/*
 * Equipment screen mod
 */
void ShowEncumberance(void)
{
	int encumberance=GetUnitEncumberance(*unitIdx);
	unsigned char strength=(*currentUnit_pUnitRef)->Strength;
	unsigned char accuracy=(*currentUnit_pUnitRef)->Firing_Acc;
	unsigned char reaction=(*currentUnit_pUnitRef)->React_Current;
	unsigned char psi_strength=(*currentUnit_pUnitRef)->Psi_Strength;
	unsigned char psi_skill=(*currentUnit_pUnitRef)->Psi_Skill;

	static char weight_str[16]={"Weight>"};
	static char accuracy_str[16]={"Accur>"};
	static char reaction_str[16]={"React>"};
	static char psi_strength_str[16]={"MC.Str>"};
	static char psi_skill_str[16]={"MC.Skill>"};
	static int init=0;
	if(init==0) 
		{
		init=1;
		INI_READ_STRING("Equipment Screen","Weight","Weight>",weight_str,16);
		INI_READ_STRING("Equipment Screen","Accuracy","Accur>",accuracy_str,16);
		INI_READ_STRING("Equipment Screen","Reaction","React>",reaction_str,16);
		INI_READ_STRING("Equipment Screen","Psi Strength","MC.Str>",psi_strength_str,16);
		INI_READ_STRING("Equipment Screen","Psi Skill","MC.Skill>",psi_skill_str,16);
		}

	//Draw weight stats
	DrawString(weight_str,0x40,24,245,1);
	if(encumberance>strength)
		DrawNumber(encumberance,0x20,*carretPosition,1);
	else
		DrawNumber(encumberance,0x10,*carretPosition,1);

	DrawSmallLetter('/',0x40,*carretPosition);
	DrawNumber(strength,0x30,*carretPosition,1);

	//Only draw other stats during equiping phase
	if(*tactical_mainState != 2)
	{
		DrawString(accuracy_str,0x40,32,245,1);
		DrawNumber(accuracy,0x10,*carretPosition,1);

		DrawString(reaction_str,0x40,40,245,1);
		DrawNumber(reaction,0x10,*carretPosition,1);

		//Only draw psi stats when unit has been in psi-lab
		if(psi_skill)
		{
			DrawString(psi_skill_str,0x40,48,245,1);
			DrawNumber(psi_skill,0x10,*carretPosition,1);

			DrawString(psi_strength_str,0x40,56,245,1);
			DrawNumber(psi_strength,0x10,*carretPosition,1);
		}
	}
}

void FixClipWeight()
{
unsigned int OBPOSDAT=0x4D85E0;

for(unsigned char i=0xD2; i==0; i--)
	{
	unsigned object=OBPOSDAT+(i*16);
	if (*(char *)object != 0xFF)
		{
		if(*(short *)(object+6) != 0xFFFF)
			{
			unsigned short weapon=*(short *)(object+6);
			unsigned char owner=*(char *)(OBPOSDAT+(weapon*16)+4);
			*(short *)(object+4)=owner;
			}
		}
	}
}


/*
 * The procedure that randomizes the shots trajectory is bugged when shooting vertically.
 * We disable it when it is the case to fix the blaster bomb bug.
 */
void FixedAccuracyCompensation()
{
	short x1=*(short *)0x48E51C; //was 0x4783F8
	short y1=*(short *)0x48E51E; //0x4783FA
	short x2=*(short *)0x48E524; //0x478400
	short y2=*(short *)0x48E526; //0x478402

	if( x1 == x2 && y1 == y2 ) //vertical shot
		return;

	AdjustShotWithAccuracy();
}

/*
 * Trigger reaction fire when units turn
 * The two functions are called when the unit's orientation change
 */
void ReactionFire1()
{
	((void (*)())(0x431410))();  //was 0x42DD50
	__asm pusha
	if(*isDuringReactionFire == 0)
		PerformReactionFire();
	__asm popa
}

void ReactionFire2(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)
{
	ComputeVisibleAliens(xpos, ypos, zpos, orientation, distance);
	__asm pusha
	if(*isDuringReactionFire == 0)
		PerformReactionFire();
	__asm popa
}

__declspec(naked) void CheckForDepth()
{
	__asm
	{
	movsx   eax, al
	lea     eax, [eax+eax*2]
	lea     edx, [eax+eax*8]
	mov     eax, dword ptr ds:4D6338h
	lea     ecx, [eax+edx*2]	
	mov     al, [eax+edx*2+2Eh]  //obj shoots?
	test    al, al
	jz      nosnapshot
	mov		eax, 0
	cmp 	byte ptr 48DF48h[eax],0 //tactical depth
	jnz		snapshot
	xor		eax,eax
	mov		al, byte ptr [ebp+0]
	mov		ax, word ptr 475664h[eax*2]
	test	al, al      //cannot use on land?
	jnz		nosnapshot
snapshot:
	mov		al, 1
	ret
nosnapshot:
	mov		al, 0 
	ret
	}
}

__declspec(naked) void CheckTankForDepth()
{
	__asm
	{
		mov		eax, 0
		cmp 	byte ptr 48DF48h[eax*2],0
		jnz		underwater
		mov		al,[edi+75h]
		cmp		al,1
		jz		invalid
underwater:	
		mov		cl,[edi+76h]
		test	cl,cl
		ret
invalid:
		cmp		al,1
		ret
	}
}

__declspec(naked) void GaussTankAmmo()
{
	__asm
	{
		cmp		ax, 2
		jnz		pwt
		movsx	eax, word ptr ds:4CB4CEh[0]
		lea		ecx, [eax+eax*8]
		lea		edx, [eax+ecx*4]
		mov		eax, ds:4CB4B8h[0]
		lea		eax, [eax+edx*8+0xD0]
		add		word ptr[eax],2Ah
		jmp		done
	pwt:
		cmp		ax, 4
		jnz		error 
		movsx   eax, word ptr ds:4CB4CEh[0]
		lea     ecx, [eax+eax*8]
		lea     edx, [eax+ecx*4]
		mov     eax, ds:4CB4B8h[0]
		lea     eax, [eax+edx*8+0xCE]
	done:
		ret
	error:
		xor		eax,eax
		ret
	}
}

__declspec(naked) void GaussTankAmmo2()
{
	__asm
	{
	cmp     byte ptr [edi+2Eh], 2
	jnz     skip1
	lea     ecx, [eax+eax*8]
	lea     edx, [eax+ecx*4]
	mov     ecx, dword ptr ds:4CB4B8h
	lea     ecx, [ecx+edx*8+0D0h]
	movzx   dx, byte ptr [edi+76h]
	add     [ecx], dx
skip1:
	cmp	byte ptr[edi+2Eh], 4
	jnz	skip2
	lea     ecx, [eax+eax*8]
	lea     edx, [eax+ecx*4]
	mov     eax, dword ptr ds:4CB4B8h
	movzx   cx, byte ptr [edi+76h]
	add     [eax+edx*8+0CEh], cx
	lea     eax, [eax+edx*8+0CEh]
skip2:	
	ret
	}
}

__declspec(naked) void GaussTankAmmo3()
{
	__asm
	{
		xor     ax, ax
		mov     [esp+10h], 1
		mov     al, bl
		add     [ecx+28h], ax
		mov     eax, 51EB851Fh
		imul    edx
		sar     edx, 4
		mov     eax, edx
		shr     eax, 1Fh
		add     edx, eax
		mov     [ebp+8], dl
		movzx   dx, dl
		sub     [ecx+28h], dx
	}
}

__declspec(naked) void FixHallucinoidStun()
{
	__asm
	{
		mov     [ebp+78h], ecx
		mov     byte ptr [ebp+6Fh], 0
		mov     byte ptr [ebp+71h], 0
		mov     byte ptr [ebp+72h], 0
		mov     byte ptr [ebp+73h], 0
		mov     byte ptr [ebp+74h], 0
		mov     byte ptr [ebp+75h], 0FFh
		mov     byte ptr [ebp+76h], 0
		cmp		al, 0Dh
		jnz	skip
		mov     byte ptr [ebp+75h], 5
		mov     byte ptr [ebp+76h], 0FFh
	skip:
		cmp     al, 9
		ret
	}
}

__declspec(naked) void FixDeepOneGun()
{
	__asm
	{
		mov     byte ptr [ebp+75h], 7
		mov     byte ptr [ebp+76h], 0FFh
		mov		byte ptr [ebp+36h], 11h
		ret
	}
}

__declspec(naked) void StunBlastMod()
{
	__asm
	{
		cmp		byte ptr [esp+0Ch+1Ch], 6
		jnz		skip
		mov		[esp+0Ch+18h], 2
	skip:
		mov		eax, 48DC80h 
		mov		ecx, 40BD5Bh
		jmp		ecx 
	}
}

/*
 * Repopulate the activated proximity grenade list during each loop of the battlescape.
 * This is crude but effective. As an added bonus, it reduces the speed of the game ;-)
 * Better solution would be to update it only during unit movement.
 */
void FixProximityMines()
{
	__asm push ecx
	for(int i=0;i<20;i++) {
		tac_prox_mine_list[i].active=0;
	}
	int mine_idx=0;

	for(int i=0;i<170;i++)
	{
//		unsigned char *pObpos=&pObpos_dat[i*16];
		obpos_dat *pObpos=&pObpos_dat[i];
//		if(pObpos[0]==0x15&&pObpos[8]==1&&pObpos[4]==-1) //armed prox mine on the ground
		if(pObpos->itemType==0x15&&pObpos->quantity1==1&&pObpos->owner==0xff) //armed prox mine on the ground
		{
			tac_prox_mine_list[mine_idx].active=1;
			tac_prox_mine_list[mine_idx].pObpos=pObpos;
			mine_idx++;
			if(mine_idx==20)
				break;
		}
	}

	__asm pop ecx
	ActAccordingToTacticalState();
}

/*
 * Explosions give experience to the "current unit". For proxmines, developers forget to change it before generating
 * the explosion and the experience does not go to the correct unit.
 */
void FixProximityMinesExperience(int xpos, int ypos, __int16 zpos, int strength, int a, int b, __int16 c)
{
	unsigned char *pObpos;
	unsigned char thrower_idx;
	
	//save the current unit
	short saved_idx=*currentUnit_idx;

	__asm 
	{
		mov eax,[esi+2];
		mov pObpos,eax;
	}

	//set current unit to the thrower
	thrower_idx=pObpos[9];
	SetCurrentUnit(thrower_idx);
	
	//boom!
	GenerateExplosion(xpos, ypos, zpos, strength, a, b, c);

	//restore the current unit
	SetCurrentUnit(saved_idx);
}

/*
 * Helper to draw dialog boxes
 */
void DrawDialog(char *line1, char *line2)
{
	//Draw box
	((void (*)(int,int,int,int,int))(0x421410))(0x30,0x32,0x58,0xDC,1); //was 0x41E3F0


	*DrawText_leftBorder=0xA0;
	DrawString(line1,0x10,0x40,0x50,0);
	*DrawText_leftBorder=0xA0;
	DrawString(line2,0x10,0x50,0x50,0);
	*ui_numButtons=0;

	//"OK" button
	CreateButton(0x70,0x64,0x12,0x78,0x10,StringTable_battlescape[77]);

	((void (*)(int))(0x42F680))(1);

	WaitTillMouseButtonsAreReleased();
	while(!CheckForClickedButton());
}


/*
 * Elerium ships have a constant consumption rate of 1 (for standard ship, consumption is based on ship speed).
 * This rate is used at 2 places: to know when the ship has burnt half its fuel, and to determine how much distance
 * it can still fly. The second part is buggy however and uses the standard ship formula so we end up with a fly distance
 * of 0 and the ship returns immedialty. This should fix the issue.
 */
__declspec(naked) void ZrbiteShipFix()
{
	__asm
	{
		mov		eax,edi
		cdq
		cmp		bl,0
		jz		std_fuel
		cmp		bl,3
		jz		std_fuel
		ret
std_fuel:
		idiv	ecx
		ret
	}
}

/*
 * Call the PrepCorpse function when an unconscious body is destroyed.
 * This gets the location of the body object and transfers the position data to the unit
 * that the body object represents. 
 */

void PrepCorpse()
{
	char unitidx;
	__asm
	{
	 mov	unitidx, al
	 push	ecx
	 push	ebx
	 xor	ecx, ecx
	 and	eax, 0xFF
	 mov	ebx, 0x4D5020
	 imul	ax, 14
	 lea	ecx, [ebx+eax]
	 xor	ebx, ebx
	 mov	bl, byte ptr [esi-5]
	 mov	byte ptr [ecx+0], bl
	 mov	bl, byte ptr [esi-4]
	 mov	byte ptr [ecx+1], bl
	 mov	bl, byte ptr [esi-3]
	 mov	byte ptr [ecx+2], bl
	 pop	ebx
	 pop	ecx
	 xor	eax, eax
	 mov	al, unitidx
	 push   eax
	 call	Tactical_KillUnit
	}
 }
/*
unsigned char GetCorpseID(unsigned char UnitPos)
{
	obpos_dat *pObPos=pObpos_dat;

	for(unsigned char i=0;i>209;i++)
	{
		if(pObPos->itemType != 0xffff)
		{
		   if (pObPos->itemType > 0x1E && pObPos->itemType < 0x22)
			{
			 if (pObPos->quantity1 == UnitPos)
				{
				return i;
				}
			}
		}
		pObPos++;
	}
	return 0xff;
}
*/
void EOB_PreCheck()
{
unsigned char alien=0, apuppet=0, xcom=0, xpuppy=0;
int UnitPOS_0A=0x4D502A;
	__asm
		{
		mov     edx, UnitPOS_0A
		mov     esi, 50h
	loop_start:
		mov     eax, [edx]
		test    al, 2  //active unit
		jz      loop_end 	
		test    al, 4  //big or small unit
		jnz     loop_end
		mov     cl, [edx-1]
		cmp     cl, 0     //unit xcom?
		jz		xcom_side
		cmp		cl, 1   //unit alien
		jz		alien_side
		jmp		loop_end
	alien_side:
		test    al, 40h    
		jnz     a_puppet  //unit a mced alien?
		inc     alien
		jmp     loop_end
	a_puppet:
		inc     apuppet
		jmp		loop_end
	xcom_side:                             
		test    al, 40h  //mced alien?
		jnz     x_puppy
		inc     xcom
		jmp     loop_end
	x_puppy:
		inc		xpuppy
		jmp		loop_end
	loop_end:
		add     edx, 0Eh
		dec     esi
		jnz     loop_start
		}
	if (alien==0)
	{
		if (apuppet>0) 
		{
			__asm
			{
				mov     edx, UnitPOS_0A;
				mov     esi, 50h
			loop_start2:
				mov     eax, [edx]
				test    al, 2
				jz		loop_end2
				test    al, 4
				jz      valid_unit2
				test    al, 18h
				jnz     loop_end2
			valid_unit2:
				mov     cl, [edx-1]
				cmp     cl, 1
				jnz     loop_end2
				test    al, 40h
				jz      loop_end2			
				and		eax, 0FFBFh //unit is a MCed soldier, clears the mind control
				mov		[edx],al
				mov		[edx-1],0
		 loop_end2:
				add     edx, 0Eh
				dec     esi
				jnz     loop_start2
			}
		}
	}
Tactical_TestForEndOfBattle();
}


__declspec(naked) int UnitCountFix()
{
	__asm
	{
	mov     eax, [esi]
	test    al, 2
	jz		skip1
	mov		ecx, dword ptr [esi-6]
	cmp		byte ptr [ecx+0Dh], 0
	jz		skip1
	mov     cl, byte ptr [esi-1]
	ret
	skip1:
	mov		cl, 1
	ret
	}
}

__declspec(naked) void KoMCfix ()
{
	__asm
	{
		mov    ecx, [edi+0Ah]  //edi is current unit's unitpos memory ref
		test   cl, 40h
		jnz    end
		mov    ecx, [edi+04]
		mov    dl, [ecx+0]
		mov    ecx, [edi+0Ah]
		and    ecx, 3Fh
		mov    [edi+0Ah], ecx
		cmp    dl, 3
		jl     xcom
		cmp    dl, 0Fh
		jl     alien
		mov    [edi+9], 2
		jmp    end
		xcom:
		mov    [edi+9], 0
		jmp    end
		alien:
		mov    [edi+9], 1
		end:
		ret
	}
}

__declspec(naked) void KOUnitFix()
{
	__asm
		{
		mov		eax, [ecx+4]
		cmp		byte ptr [eax+0Dh], 0	
		jz		end
		xor		eax, eax
		mov		eax, [ecx+0Ah]
		or      al, 2
		mov     [ecx+0Ah], eax
		mov     di, word ptr ds:4D6294h
		mov     byte ptr [edx], 0FFh
		mov     eax, [ecx+4]
		cmp     di, 3
		jl    	end
		cmp		di, 5
		jle		multi
		cmp		di, 7
		jz		multi
		cmp		di, 9
		jnz		end
		multi:
		mov		byte ptr [eax+0Eh], 0
		mov		cl,[eax+1Bh]
		mov		byte ptr [eax+0Fh], cl
		mov		byte ptr [eax+03Ah], 100
		push	edx
		mov		dl, [eax+1Ah]
		mov		cl, [eax+0Dh]
		sub		dl, cl
		cmp		dl, 0Ah
		jle		skip
		mov		dl, 0Ah
		skip:
		add		byte ptr [eax+0Dh], dl 
		pop  	edx
		add		eax, 3Fh
		mov		ecx, 6
		loc_416122:
		cmp     byte ptr [eax], 0
		jz      loc_41612A
		mov     byte ptr [eax], 1
		loc_41612A:
		inc     eax
		dec     ecx
		jnz     loc_416122
		mov     di, word ptr ds:4D6294h
		end:
		ret
		}
}

__declspec(naked) void AbortClipFix()
{
	__asm
	{
		cmp     word ptr [esi+2],0FFFFh
		jz		notclip
		xor     eax, eax
		movsx   eax, [esi+2]
		imul	eax, 10h
		mov		ecx, 4D85E0h  //mem offset for OBPOS.DAT
		add     eax, ecx
		xor 	ecx, ecx
		movsx 	cx, byte ptr [eax+1]
		mov		byte ptr [esi-3],cl
		movsx	cx, byte ptr [eax+2]
		mov		byte ptr [esi-2],cl
		movsx	cx, byte ptr [eax+3]
		mov		byte ptr [esi-1],cl
	notclip:
		ret
	}
}

void AbortPreEOB()
{
	unsigned char apuppet=0, xpuppy=0;
	unsigned int UnitPOS_0A=0x4D502A;
	__asm
		{
		mov     edx, UnitPOS_0A
		mov     esi, 50h
	loop_start:
		movsx   eax, [edx]
		test    al, 2  //active
		jz		loop_end //non active
		test    al, 4  //big or small unit
		jz      valid_unit
		jmp     loop_end
	valid_unit:
		mov     cl, [edx-1]
		cmp     cl, 1     //unit alien?
		jnz     x_unit
		test    al, 40h   
		jz		loop_end  //unit a true alien no MCed aquanaut
		inc     apuppet
		jmp		loop_end
	x_unit:                             
		test    cl, cl
		jnz     loop_end  //unit is civilian
		test    al, 40h
		jnz     x_puppy  //unit is MCed alien
		jmp     loop_end
	x_puppy:
		inc		xpuppy
	loop_end:
		add     edx, 0Eh
		dec     esi
		jnz     loop_start
		}
	if (apuppet>0)
		{
			__asm
			{
				mov     edx, UnitPOS_0A;
				mov     esi, 50h
			loop_start2:
				mov     eax, [edx]
				test    al, 2
				jz      loop_end2
				test    al, 4
				jz      valid_unit2
				test    al, 18h
				jnz     loop_end2
			valid_unit2:
				mov     cl, [edx-1]
				cmp     cl, 1
				jnz     x_unit2
				test    al, 40h
				jz      loop_end2			
				and		eax, 0FFBFh //unit is a MCed soldier, clears the mind control
				mov		[edx],al
				mov		[edx-1],0
				jmp     loop_end2
			x_unit2:                             
				test    cl, cl  
				jnz     loop_end2 // unit is a civilian
				test    al, 40h
				jz		loop_end2   //unit is not MCed alien
			loop_end2:
				add     edx, 0Eh
				dec     esi
				jnz     loop_start2
			}
		}
Tactical_TestForEndOfBattle();
}

__declspec(naked) void BaseTankAmmoFix()
{
	__asm
	{
    	cmp     word ptr ds:4D6294h, 2  //Is this a base defense misssion
		mov     [esp+10h], edx  //randomly used variable
		jnz		awaymis
		xor     edx, edx
		cmp     bx, 3
		jz      noammo		
		mov     edi, [esp+18h]  //current base memory offset
		and     eax, 0Fh
		xor     esi, esi
		cmp     bx, 1
		jz      torpedo
		cmp     bx, 2
		jz      gauss 
		cmp     bx, 4
		jz      PWT
		mov     esi, [esp+30h] //number of remaining tanks to spawn
		mov     ax, word ptr [edi+0CAh]
		and     eax, 0FFFFh
		idiv    esi
		cmp     ax, 1Eh
		jle		nocap
		mov     ax, 1Eh
	nocap:
		mov     [ebp+76h], al
		sub     word ptr [edi+0CAh], ax
		jmp     end
	torpedo:
		mov     esi, [esp+30h] //number of remaining tanks 
		mov     ax, word ptr [edi+0CCh]
		and     eax, 0FFFFh
		idiv    esi
		cmp     ax, 8
		jle		nocap1
		mov     ax, 8
	nocap1:
		mov     [ebp+76h], al
		sub     word ptr [edi+0CCh], ax
		jmp     end
    PWT:
		mov     esi, [esp+30h] //number of remaining tanks
		mov     ax, word ptr [edi+0CEh]
		and     eax, 0FFFFh
		idiv    esi
		cmp     ax, 8
		jle		nocap2
		mov     ax, 8
	nocap2:
		mov     [ebp+76h], al
		sub     word ptr [edi+0CEh], ax
		jmp     end
	gauss:
		mov     esi, [esp+30h] //number of remaining tanks to spawn
		mov     eax, [edi+0D0h]
		and     eax, 0FFFFh
		idiv    esi
		cmp     ax, 32h
		jle		nocap3
		mov     ax, 32h
	nocap3:
		mov     [ebp+76h], al
		sub     word ptr [edi+0D0h], ax
		jmp     end 
	awaymis:
		cmp     bx, 3
		jz      noammo
		mov     byte ptr [ebp+76h], 1Eh
		test    bx, bx
		jz      end
		mov		byte ptr [ebp+76h], 32h
		cmp     bx, 2
		jz      end
		mov     byte ptr [ebp+76h], 8
		jmp     end
	noammo: 
		mov     byte ptr [ebp+76h], 0FFh
	end:
		mov     edx, [esp+10h]  //randomly used variable
		xor     eax, eax
		mov     edi, 456F74h
		jmp     edi
	}
}

void clipweightassign () 
{
	char   CurrentUnitIdx=*(char*)0x48E4D8;
	short  CurrentSelectedObjIDX=*(short*)0x48E4E0;

	for(unsigned char i=0; i<0xD2;i++)
	{
		int UnkObjOBPOSref=0x4D85E0+(i*16);
		if (*(char *)UnkObjOBPOSref!=0xFF)
			{
			if(*(short *)(UnkObjOBPOSref+6)!=0xFFFF)
				{
				if (*(short *)(UnkObjOBPOSref+6)==CurrentSelectedObjIDX)
					{
					*(char *)(UnkObjOBPOSref+4)=CurrentUnitIdx;
					}
				}
			}
	}
}


void clipweightremove ()
{
	short CurrentSelectedObjIDX=*(short*)0x48E4E0;
	
	for(unsigned char i=0; i<0xD2;i++)
	{
		int UnknObposref=0x4D85E0+(i*16);
		
		if (*(char *)UnknObposref!=0xFF) //Is this a valid object?
			{
			if(*(short *)(UnknObposref+6)!=0xFFFF)  //Is this object ammo?
				{
				if (*(short *)(UnknObposref+6)==CurrentSelectedObjIDX)
					{
					*(char *)(UnknObposref+4)=0xFF;
					}
				}
			}
	}
}

__declspec(naked) void ClipFixHook1()  //41C025
{
	__asm
	{
	mov     al, byte ptr ds:48E4D8h
	mov		byte ptr [esi+4], al
	call	clipweightassign
	mov     word ptr ds:48E4EEh, 1
	ret
	}
}

__declspec(naked) void ClipFixHook2()  //41BE51
{
    __asm
	{
	mov     byte ptr [esi+4], 0FFh
	call	clipweightremove
	mov     cl, byte ptr ds:48E260h //tactical playing side
	ret
	}
}

__declspec(naked) void ClipFixHook3()  //41C039
{
    __asm
	{
	mov     byte ptr [esi+4], 0FFh
	call    clipweightremove
	mov     word ptr ds:48E4EEh, 1
	ret
	}
}


__declspec(naked) void ClipFixHook4() //Panic drop 422D8D
{
    __asm
	{
	mov     byte ptr [esi], 0FFh
	call    clipweightremove
    mov     [esi-1], bl
	ret
	}
}

__declspec(naked) void ClipFixHook5()  //throw
{
	__asm
	{
		mov     byte ptr [eax+4], 0FFh
		call	clipweightremove
		mov     ax, word ptr ds:4CD65Ch
		ret
	}
}

__declspec(naked) void ImprovedDetector()
{
	__asm
	{
	cmp 	byte ptr [esi-1], 1
	jnz		loc_40B452
	movsx   eax, ax
	shr		eax, 2    //added--stay disabled
	movsx   ecx, cx
	mov     edx, dword ptr ds:4E0930h
	lea     eax, [eax+eax*4]
	shr		ecx, 2		//added--stay disabled
	shl     eax, 6
	add     eax, ecx
	xor     ecx, ecx
	lea     edi, [edx+eax*8+737Ch]
	mov     eax, dword ptr [esi-6]
	mov     cl,  byte ptr [eax+3Eh]
	cmp     cl, 5
	jg      skip1
    mov		cl, 5
skip1:
	mov     eax, 66666667h
	imul    ecx
	sar     edx, 1
	mov     ecx, edx
	shr     ecx, 1Fh
	add     edx, ecx
	cmp     dl, 5
	jbe     loc_40B433
	mov     dl, 5
	loc_40B433:
	movzx   ax, byte ptr ds:48E342h
	xor     cx, cx
	mov     cl, dl
	add     eax, ecx
	push    eax             
	push    edi             
	call    Draw16x16Sprite
	mov     ebp, dword ptr ds:4D85C0h
	add     esp, 8
	loc_40B452:
	ret
	//mov     edx, 40B452h
	//jmp     edx
	}
}

_declspec(naked) void altcolony2()
{
	__asm
	{
	mov     byte ptr ds:4CB220h, 3  //site depth
	mov     edi, 1
	ret
	}
}

_declspec(naked) void altartifactrace()
{
	__asm 
		{
		mov     ecx, dword ptr ds:4CB4F8h
		lea     edx, [eax+eax*4]
		lea     eax, [eax+edx*2]
		lea     eax, [eax+eax*4]
		movsx    si, byte ptr [ecx+eax*2+5Ch]
		push    64h
		call    GetRandom_0_n
		add		esp, 4
		xor		esi, esi
		cmp     al, 0Ah
		jle     end
		cmp     al, 14h
		mov     esi, 1
		jle     end
		mov     esi, 3
		cmp     al, 1Eh
		jle		end
		mov		esi, 4
		cmp     al, 3Ch
		jle		end
		mov     esi, 5
	end:
		mov     eax, 4552D8h
		jmp		eax
		}
}
/*
_declspec(naked) void altartifact2b()
{
	__asm //454EDE
		{
		//push	4
		//call	GetRandom_0_n
		//lea		eax, [eax+eax]
		push	1
		call	GetRandom_0_n
		xor     esi, esi
		movsx	eax, ax
		lea		eax, [eax+eax*2]
		mov		si, ax
		push	1
		add		si, ax
		movsx	eax, si
		add		esp, 8
		xor		esi, esi
		mov		byte ptr 4D936Ch[eax], 0Fh
		mov		byte ptr 4D936Ch+1[eax], 0FFh
		mov		byte ptr 4D936Fh[eax], 0FEh 
		mov		byte ptr 4D9370h[eax], 0FDh 
		ret
		}
}

_declspec(naked) void altartifact2c()
{
	__asm //454F3F
		{
		push 	3
		call	GetRandom_0_n
		xor		ecx, ecx
		add		cx, 2
		lea		cx, [ecx+eax*2]
		add		esp, 4
		ret
		}
}
*/

const char *GetObjectDescription(const char *defaultDescription)
{
	unsigned char *pObpos=(unsigned char *)&pObpos_dat[*inventory_draggedItem_obPosIdx];
	static int init;
	static char primed[16]={"primed"};
	//if(init==0) {
	//	init=1;
	//	INI_READ_STRING("Equipment Screen","Primed","primed",primed,16);
	//}

	switch(*inventory_draggedItem_objectType)
	{
	case 0x13://grenade
	case 0x14://smoke
	case 0x16://HE
	case 0x2c://alien grenade
	case 0x15://proximity
		if(pObpos[8]!=0)//quantity1
		{
			static char str[128];
			sprintf(str,"%s (%s)",defaultDescription,primed);
			return str;
		}
		//fall through
	default:
		return defaultDescription;
	}
}

__declspec(naked) void GrenadeState(void)
{
	static int saved;
	__asm
	{
		mov		edx, [0x4D4AE0+ecx*4] //was 0x49D660
		pusha
		push	edx
		call	GetObjectDescription
		add		esp,4
		mov		saved,eax
		popa
		mov		edx, saved
		ret
	}
}


void SwitchSoldiers(unsigned char *a, unsigned char *b)
{
	//size of SOLDIER.DAT entry = 70
	unsigned char tmp[70];
	memcpy(tmp,a,70);
	memcpy(a,b,70);
	memcpy(b,tmp,70);
}

void CrewDlgAddUpDownButton(const char *str, int color, __int16 ypos, __int16 xpos, int smallFont)
{
	DrawString(str, color, ypos, xpos, smallFont);

	AddDialogButton(0xC4+8, 2);
	AddDialogButton(0xD0+8, 3);
}

int GetItemEntryFromId(int id)
{
	for(int i=0;i<*DlgNumItems;i++)
	{
		if(DlgItemIdList[i]==id)
			return i;
	}
	return -1;
}

void CrewHook()
{
	int now = timeGetTime();
	int moveOnTop = 0;

	WaitTillMouseButtonsAreReleased();

	if(timeGetTime()-now>200)
		moveOnTop=1;

	if(*DlgDialog_ClickedItem==0xffff)
		return;

	unsigned char *currentSoldier=*pSoldierDat+70**DlgDialog_ClickedItem;  //? problem

	if(*mouse_xpos<128)
	{
		unsigned short baseIdx = *(unsigned short *)(currentSoldier+6);
		ShowSoldierStat(*DlgDialog_ClickedItem, baseIdx);
		*DlgDialog_ClickedItem=0xffff;
		return;
	}

	if(*DlgUpperLowerButtonPressed)
	{
		int entry=GetItemEntryFromId(*DlgDialog_ClickedItem);

		if(*DlgUpperLowerButtonPressed==4) //down
		{
			if(entry<*DlgNumItems-1)
			{
				if(moveOnTop)
				{
					while(entry<*DlgNumItems-1)
					{
						unsigned char *current = *pSoldierDat+70*DlgItemIdList[entry];
						unsigned char *next = *pSoldierDat+70*DlgItemIdList[entry+1];
						SwitchSoldiers(current, next);
						entry++;
					}
				}
				else
				{
					unsigned char *nextSoldier=*pSoldierDat+70*DlgItemIdList[entry+1];
					SwitchSoldiers(currentSoldier,nextSoldier);
				}
			}
		}
		else if(*DlgUpperLowerButtonPressed==3) //up
		{
			if(entry>0)
			{
				if(moveOnTop)
				{
					while(entry>0)
					{
						unsigned char *current = *pSoldierDat+70*DlgItemIdList[entry];
						unsigned char *previous = *pSoldierDat+70*DlgItemIdList[entry-1];
						SwitchSoldiers(current, previous);
						entry--;
					}
				}
				else
				{
					unsigned char *previousSoldier=*pSoldierDat+70*DlgItemIdList[entry-1];
					SwitchSoldiers(currentSoldier,previousSoldier);
				}
			}
		}

		*DlgDialog_ClickedItem=0xffff;
	}
}

__declspec(naked) void FixDoorJam(void)
{
	__asm
	{
		add     bl, dl        //.text:0041B97B 02 DA                         add     bl, dl
		mov     [eax+46], bl  //.text:0041B97D 88 58 2E                      mov     [eax+structMCDData.openedDoorTile], bl
		cmp		[eax+0x1E],1  //sliding door
		jnz		skip
		push	ebx
		push	esi 
		and		ebx,0xff
		mov		esi, ebx
		shl		esi, 5
		sub		esi, ebx
		shl		esi, 1
		mov		byte ptr [esi+0x4DBD4F],1 //mcd "keycode"
		pop		esi
		pop		ebx
skip:
		ret
	}
}

__declspec(naked) void FixScientistsEngineersOverflow(void)
{
	__asm
	{
		mov     dl, [ecx]
		add     dl, al
		jnc     nooverflow
		mov     dl, 255
nooverflow:
		mov     [ecx], dl
		ret
	}
}

void CreateCraftDeequipButton(int ypos, int xpos, int height, int width, int color, char *str)
{
//		int __cdecl CreateButton(int ypos, int xpos, int height, int width, int color, char *str)
	CreateButton(ypos, xpos-8, height, width, color, str);
	CreateButton(*(short *)0x4CC372+*(short *)0x4CB21E,*(short *)0x4CC32E+0x28+0x46+8,0x10,0x46,*(char *)0x4CB43E,"DE-EQUIP");
	//                       0x49B952           0x49A83E           0x49B90E                                0x49AA5E
}

__declspec(naked) void ExitCraftArmament(void)
{
	__asm
	{
//		 .data:0049B860 ?? ??                         DlgClickedButton dw ?                   ; DATA XREF: BuildFacilities+5Dr

		push esi
		mov esi, 0x4CC240  //[was 0x49B860] --Clicked button
		cmp word ptr [esi], 1
		pop esi
		jz short cancel

		push edi
		mov edi,[esp+12]
		mov eax,0x45F2A5 //was 0x4569E5
		jmp eax
cancel:
		pop esi
		ret
	}
}


/*
.text:00434D47 8A 04 0A                      mov     al, [edx+ecx]
.text:00434D4A 84 C0                         test    al, al
*
*/
/*
 __declspec(naked) void AssignAllScientists1() //
{
	__asm
	{
	mov     eax, dword ptr 4CB510h
	mov     edx, [esp+20h]
	mov     [esp+14h], 1
	mov     bl, [edx+eax]
	inc     bl
	test	bl,bl
	jz	end
	mov     [edx+eax], bl
	mov     edx, [esp+28h]
	mov     eax, [esp+10h]
	dec     edx
	dec     eax
	mov     [esp+28h], edx
	mov     [esp+10h], eax
	end:
	ret
	}
}
 
__declspec(naked) void AssignAllScientists2() //__declspec(naked) 
{
	//ebp = available scientist
	//ebx = available lab space
	//[edx+ecx] = assigned scientists
	__asm
	{
	//lea ecx,[edx+ecx]
	mov al, [edx+ecx]
	test al,al
	jnz all
	mov eax,[esp+28h]//28h]
	cmp eax,[esp+10h]//10h]
	jnl skip2
	xor eax,eax
	mov al,[esp+28h]//28h]
	jmp skip3
	skip2:
	xor eax,eax
	mov al,[esp+10h]//10h]
	skip3:
	mov cl,al
	mov [esp+18h],1 //18h
	sub [esp+28h],eax  //28h
	sub [esp+10h],eax  //10h
	jmp	end
	all:
	dec     al
	mov     [esp+18h], 1  //1Ch
	mov     [edx+ecx], al
	mov     ecx, [esp+28h]  //28h
	mov     eax, [esp+10h]  //10h
	inc     ecx
	inc     eax
	mov     [esp+28h], ecx  //28h
	mov     [esp+10h], eax	//10h
	end:
	//ret
	}
}
*/
/*	
	
	__asm
	{	
		push ebx
		push ebp
		mov ebp, [esp+40] // put in KY
		mov ebx, [esp+16] // put in KY
		mov al,[edx+ecx]
		test al,al
		jz assign_all
		ret
assign_all:
		mov [esp+24],1
		cmp ebx, ebp
		jl lab_space_full
//enough space for everyone
		mov eax, ebp
		mov [edx+ecx], al
		sub ebx, ebp
		xor ebp,ebp
		test ebp,ebp
		ret

lab_space_full:
		mov [edx+ecx], bl
		sub ebp,ebx
		xor ebx,ebx
		test ebx,ebx
		pop ebx
		pop ebp
		ret
	}
}
// reworked !!! hopefully right KY

//.text:00436311 66 8B 84 71 8C 00 00 00       mov     ax, [ecx+esi*2+8Ch]
//.text:00436319 66 3B C2                      cmp     ax, dx
*/
/*
__declspec(naked) void AssignAllEngineers()
{
	// [esp+40] -> n available engineer
	// [esp+44] -> n available build space
	// [ecx+esi*2+0ACh] -> assigned engineers
	// edx -> 0
	__asm
	{
		lea		ecx, [ecx+esi*2+0ACh]
		mov     ax, [ecx]
		test    ax, ax
		jz      skip1
		mov		eax,[esp+40h]
		cmp		eax,[esp+44h]
		jnl		skip2
		mov		eax,[esp+40h]
		jmp		skip3
		skip2:
		mov		eax,[esp+44h]
		skip3:
		mov		[ecx],ax
		mov		ebp,1
		sub		[esp+40h],eax
		sub		[esp+44h],eax
		mov		[esp+2Ch],ebp
		jmp		end
		skip1:
		dec     eax
		mov     ebp, 1
		mov     [ecx], ax
		mov     ecx, [esp+40h]
		mov     eax, dword ptr [esp+44h]
		inc     ecx
		inc     eax
		mov     [esp+40h], ecx
		mov     dword ptr [esp+44h], eax
		mov     [esp+2Ch], ebp
		end:
		ret
	}
}
*/
void SaveEquipment();
void EnableObDataPatching();

__declspec(naked) void CheckMainState()
{
	__asm
	{
		mov ecx, 0x48E508  //was 0x4783E4  //cmp isDuringReactionFire, 0
		cmp byte ptr [ecx], 0
		jnz end
		mov ecx, 0x48E274  //was 0x4781DC
		cmp word ptr [ecx], 0
end:
		ret
	}
}



/*
 * Get the true owner of a unit after it got memory controlled
 * esi : pUnitRef
 * dl  : return value
 */
__declspec(naked) void GetOwner()
{
/*
  0: X-Com
  1: Alien
  2: Civilian
*/
	__asm
	{
		mov dl, [esi] //type of unit
		cmp dl, 3
		jle xcom
		cmp dl, 15
		je civ
		cmp dl, 16
		je civ
		mov dl, 1
		ret
	civ:
		mov dl, 2
		ret
	xcom:
		mov dl, 0
		ret
	}
}

__declspec(naked) void FireDamage()
{
	__asm
	{
		cmp     dl, 2
		jz      skip
		call    ApplyFireNSmokeDamage
		skip:
		push    ebp
		push    esi
		push    edi
		mov     eax, 4D85ECh
		mov		ecx, 414469h
		jmp		ecx
	}
}

__declspec(naked) void WoundCheck()
{
/*
 3: Tank
 8: Calcinite
10: Biodrone
15: Male Civ
16: Female Civ                                     
17: Zombie        
*/
	__asm
	{
		mov eax, dword ptr 4D85C0h //4D491Ch
		mov ecx,[eax+4] //unitref
		mov cx, [ecx]   //unit type
		cmp cx, 0xFF
		jz no_wound
		cmp cx,3
		jz no_wound
		cmp cx,8
		jz no_wound
		cmp cx,0x0A
		jz no_wound
		cmp cx,0x0F
		jz no_wound
		cmp cx,0x10
		jz no_wound
		cmp cx,0x11
		jz no_wound
		mov cl,0
		jmp end
no_wound:
		mov cl,1
end:	
		cmp cl,0
		ret
	}
}

void MyTacticalDrawPanicMessage(int unitIdx)
{
	if(*(short *)0x48E53C == 0)  //done
		TacticalDrawPanicMessage(unitIdx);
}

void MyTactivalViewPosPanic(int ypos, int xpos, __int16 zpos)
{
	if(*(short *)0x48E53C == 0)
		SetTacticalViewPos(ypos, xpos, zpos);
}



//--UPDATED FUNCTIONS--
ATOM __stdcall MyRegisterClassA(WNDCLASSA *lpWndClass)
{
	lpWndClass->hCursor = LoadCursor(hPatcherDLL, MAKEINTRESOURCE(IDC_EMPTY));
	lpWndClass->style = CS_HREDRAW | CS_VREDRAW;
	return RegisterClassA(lpWndClass);
}

void ClientResize(int nWidth, int nHeight);

HWND __stdcall MyCreateWindowExA(DWORD dwExStyle, LPCSTR lpClassName, LPCSTR lpWindowName, DWORD dwStyle, int X, int Y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam)
{
	char buf[128];
	int top,left,bottom,right;
	RECT rc;
	//INI_READ_STRING("Video","D3D Window Position","",buf,128);
	INI_READ_STRING("Video","D3D Window Position","",buf,64);
	//if(sscanf(buf,"%d %d %d %d",&top,&left,&bottom,&right) == 4)
	if(sscanf(buf,"%d %d",&left,&top) == 2)
	{
		right=INI_READ_INT("Video","D3D Window Width",0);
		bottom=INI_READ_INT("Video","D3D Window Height",0);
		SetRect(&rc,left,top,right,bottom);
		X=rc.left;
		if (X<0) X=0;
		Y=rc.top;
		if (Y<0) Y=0;
		AdjustWindowRect(&rc,WS_OVERLAPPEDWINDOW,FALSE);
		nWidth = rc.right - rc.left+left;
		nHeight = rc.bottom - rc.top+top;
	}

	if(!INI_READ_INT("Video","Always On Top",0))
	{
		dwExStyle&=~WS_EX_TOPMOST;
	}

	return CreateWindowExA(dwExStyle, lpClassName, lpWindowName, WS_OVERLAPPEDWINDOW, X, Y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam);
//	return CreateWindowExA(dwExStyle, lpClassName, lpWindowName, dwStyle, X, Y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam);
}

void ForceLanguage()
{
//#ifdef NDEBUG
	short lang=INI_READ_INT("Video","Force Language",0);
//#else
//	short lang=1;
//#endif
	if(lang>0 && lang<4)
	{
		*language=lang-1;
	}
	else
	{
		//select language
		((void (*)())(0x4519F0))();

	}
}

signed int __cdecl geoDrawDateTimePanel()
{
	//The position of the upper left corner of the geoscape date/time panel.
	const int baseX = 259;
	const int baseY = 74;

	char * backBufPtr;
//	signed int result;

	backBufPtr = *BackBuffer;

	BlitToBackBuffer((int)*((int*)file_geograph_geobord_scr));

	//Draw our current funds (The entire purpose of this patch!)
	DrawString("$", 2, baseY, baseX, 1);
	DrawNumber2(*(money), 2, baseY, baseX + 6, 1);

	//Draw the hours.
	if ( *(geo_currentHour) >= 10 )
	{
		DrawNumber2(*(geo_currentHour), 2, baseY + 11, baseX + 10, 1);
	}
	else
	{
		DrawNumber2(*(geo_currentHour), 2, baseY + 11, baseX + 14, 1);
	}

	//Draw the first colon.
	DrawString(":", 2, baseY + 11, baseX + 21, 1);

	//Draw the minutes.
	if ( *(geo_currentMinute) >= 10 )
	{
		DrawNumber2(*(geo_currentMinute), 2, baseY + 11, baseX + 24, 1);
	}
	else
	{	//Draw the leading zero.
		DrawString("0", 2, baseY + 11, baseX + 24, 1);
		DrawNumber2(*(geo_currentMinute), 2, baseY + 11, baseX + 29, 1);
	}

	//Draw the second colon.
	DrawString(":", 2, baseY + 11, baseX + 35, 1);

	//Draw the seconds.
	if ( *(geo_currentSecond) >= 10 )
	{
		DrawNumber2(*(geo_currentSecond), 2, baseY + 11, baseX + 38, 1);
	}
	else
	{	//Draw the leading zero.
		DrawString("0", 2, baseY + 11, baseX + 38, 1);
		DrawNumber2(*(geo_currentSecond), 2, baseY + 11, baseX + 43, 1);
	}

	//Draw the long-form day name.
	*(DrawText_leftBorder) = baseX + 30;
	DrawString(StringsTable_geoscape[*(geo_currentDayOfTheWeek) + 184], 2, baseY + 19, 0, 1);

	//Draw the day number.
	DrawNumber2(*(geo_currentDay), 2, baseY + 27, baseX + 3, 1);

	//We don't want to draw the 'st', 'nd', or 'th', because it takes up too much space.

	/*if ( *(geo_currentDay) == 1 || *(geo_currentDay) == 21 || *(geo_currentDay) == 31 )
	{
		DrawString(StringsTable_geoscape[169], 2, 101, 270, 1);
	}
	else if( *(geo_currentDay) == 2 || *(geo_currentDay) == 22 )
	{
		DrawString(StringsTable_geoscape[170], 2, 101, 270, 1);
	}
	else if ( *(geo_currentDay) == 3 || *(geo_currentDay) == 23 )
	{
		DrawString(StringsTable_geoscape[171], 2, 101, 270, 1);
	}
	else
	{
		DrawString(StringsTable_geoscape[172], 2, 101, 270, 1);
	}*/

	//Draw the short-form month name.
	DrawString(languageStuff_geoscape[month_names_index[(*geo_currentMonth)]], 2, baseY + 27, baseX + 16, 1);

	//Draw the year.
	*(DrawNumber2_useThousandSeparator) = 0;
	DrawNumber2((unsigned __int16)(*geo_currentYear), 2, baseY + 27, baseX + 36, 1);
	*(DrawNumber2_useThousandSeparator) = 1;

	//The following switch and for loop handle drawing the depressed button on the panel.
	if(INI_READ_INT("Video","Slow The Clock",0)==1)
	{
		switch ( *(geo_timeSpeed) )
		{ 	//Get the screen offset in the backbuffer to the button we're going to work on
		case 1:		//5 secs
			backBufPtr = (char *)backBufPtr + 112 * 320 + 257;
			break;
		case 2:	//1 min
			backBufPtr = (char *)backBufPtr + 112 * 320 + 289;
			break;
		case 12:	//5 min
			backBufPtr = (char *)backBufPtr + 126 * 320 + 257;
			break;
		case 60:	//30 min
			backBufPtr = (char *)backBufPtr + 126 * 320 + 289;
			break;
		case 120:	//1 hour
			backBufPtr = (char *)backBufPtr + 140 * 320 + 257;
			break;
		case 720:	//1 day
			backBufPtr = (char *)backBufPtr + 140 * 320 + 289;
			break;
		}
	}
	else 
	{
		switch ( *(geo_timeSpeed) )
		{ 	//Get the screen offset in the backbuffer to the button we're going to work on
		case 1:		//5 secs
			backBufPtr = (char *)backBufPtr + 112 * 320 + 257;
			break;
		case 12:	//1 min
			backBufPtr = (char *)backBufPtr + 112 * 320 + 289;
			break;
		case 60:	//5 min
			backBufPtr = (char *)backBufPtr + 126 * 320 + 257;
			break;
		case 360:	//30 min
			backBufPtr = (char *)backBufPtr + 126 * 320 + 289;
			break;
		case 720:	//1 hour
			backBufPtr = (char *)backBufPtr + 140 * 320 + 257;
			break;
		case 17280:	//1 day
			backBufPtr = (char *)backBufPtr + 140 * 320 + 289;
			break;
		}
	}

	//Draw the depressed button by iterating over each pixel and shifting the colors.
	for(int i = 0; i < 13; i++)
	{
		for(int j = 0; j < 31; j++)
		{
			backBufPtr[320*i + j] = 8 - backBufPtr[320*i + j];
		}
	}
	if(INI_READ_INT("Video","Clip Cursor",0)==2) {LockCursor();}

	return 0;
}

void ShowMoney()
{
	InsertCall(PatchAddr_geoDrawDateTimePanel1, geoDrawDateTimePanel);
	InsertCall(PatchAddr_geoDrawDateTimePanel2, geoDrawDateTimePanel);
	InsertCall(PatchAddr_geoDrawDateTimePanel3, geoDrawDateTimePanel);
	InsertCall(PatchAddr_geoDrawDateTimePanel4, geoDrawDateTimePanel);
	
}


void AutoSell()
{
	void handleDecrementProductionNumber();
	void jumpToProductionCompleteHandler();
	void drawNewManufactureQuantityDialogLabel();
	void drawNewMainManufactureQuantityLabel();
	void drawNewManufactureDialogEntry();

	InsertCall(0x43A24B, handleDecrementProductionNumber);
	Nop(0x43A250, 58);//35); //Nop out the unused bytes.
	InsertCall(0x44557C, jumpToProductionCompleteHandler);
	Nop(0x445581, 1); //Nop out the unused bytes.
	InsertCall(0x439FD1, drawNewManufactureQuantityDialogLabel);
	InsertCall(0x438F63, drawNewMainManufactureQuantityLabel);
	InsertCall(0x439036, drawNewManufactureDialogEntry);
	Nop(0x439036+5,58);
}

int checkPosEqual(int x1, int y1, int z1, int x2, int y2, int z2)
{
	if(x1 == x2 && y1 == y2 && z1 == z2)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

//Checks if a unit was clicked or not. For patching purposes, also checks if the same tile has been clicked twice.
int CheckIfClickedOnUnit(short ypos, short xpos, short zpos)
{
	static int oldposx = -1, oldposy = -1, oldposz = -1;
	static DWORD oldTime = 0;
	int i;
	short result = 0;

	//*clickedUnit_unitpos = *((short*)file_missdat_unitpos_dat); //Set X-COM's clicked unit position global to UnitposDat's position.
	*clickedUnit_unitpos = *((short*)UnitposDat); //Set X-COM's clicked unit position global to UnitposDat's position.


	//Loop until we find a unit that is both active and matches the position clicked.
	//If we run out of unit slots to check, then run the movement confirmation code.
	for(i = 0;
		//!(checkPosEqual(xpos, ypos, zpos, file_missdat_unitpos_dat[i].xpos, file_missdat_unitpos_dat[i].ypos, file_missdat_unitpos_dat[i].zpos) && !(!(file_missdat_unitpos_dat[i].flags & 2)));
		!(checkPosEqual(xpos, ypos, zpos, UnitposDat[i].xpos, UnitposDat[i].ypos, UnitposDat[i].zpos) && !(!(UnitposDat[i].flags & 2)));
		i++)
	{

		*clickedUnit_unitpos = (short)((short*)UnitposDat + i); //Update the clickedUnit_unitpos global with i
		if(i >= 80)
		{	//We didn't select a unit, so check movement confirmation against the old try.
			if(!checkPosEqual(xpos, ypos, zpos, oldposx, oldposy, oldposz))
			{	//Positions don't match; movement unsuccessful.
				oldposx = xpos, oldposy = ypos, oldposz = zpos;
				*clickedUnit_idx = *(char*)0x48E27E;
				oldTime = timeGetTime();

				return 1;
			}
			else if(oldTime > (timeGetTime() - 500)) //Give the player 500ms to click a second time.
			{	//Positions match and timer is good; movement successful.
				oldposx = -1, oldposy = -1, oldposz = -1;
				oldTime = 0;

				return 0;
			}
			else
			{	//Positions match, but timer expired; movement unsuccessful.
				*clickedUnit_idx = *(char*)currentUnit_idx;
				oldTime = timeGetTime();
				
				return 1;
			}
		}
	}

	if(UnitposDat[i].owner == 0)
	{	//This is an XCOM unit.
		result = 1;
		*clickedUnit_idx = (short)i;
	}
	else
	{
		if ((UnitposDat[i].flags & 1) || ((*(short*)0x48E53C) && *(char*)(currentUnit_pUnitPos + 9) == 1))
		{	//Don't allow selecting this (it's probably an alien or civilian).
			result = 2;
		}
		*clickedUnit_idx = (short)i;
	}

	return result;
}

int CheckMindControl(int y, int x, int z)
{
	if(CheckIfClickedOnUnit(y,x,z))
	{
		SetFiringPointOrigin(*currentUnit_pUnitPos);
		if(CheckHasLineOfFire(y,x,z))
		{
			return 1;
		}
		*Tactical_StatusErrorMessage=7;//no line of fire
	}
	return 0;
}
 
__declspec(naked) void MCcheck()
{
	__asm
	{
		cmp 	ds:47A3E2h[0], 1
		jz 		done
		cmp		word ptr[edi+8Ah],0
		mov		[esp+10h], 0Eh
		ret
	done:
		cmp		ds:47A3E2h[0], 1
		ret	
	}
}

void AltResearchTree()
{
unsigned int unlkresearch, unlkproduction;

	__asm
	{
		mov		unlkresearch, 449010h
		mov		unlkproduction, 449050h
		cmp		si, 19h
		jnz		skip_plastics
		push	58h
		call	unlkproduction
		add		esp, 4
skip_plastics:
		test	byte ptr ds:47A794h, 1
		jnz		skip_p_armor			//has plastic armor already been researched?
		test	byte ptr ds:47A4A8h, 1	//has aqua plastic?
		jz		skip_p_armor
		test	byte ptr ds:47A6CEh, 1 	//has deep one corpse?
		jz		skip_p_armor
		push	3Bh
		call	unlkresearch			//unlock plastic armor research
		add		esp, 4
skip_p_armor:
		test	byte ptr ds:47A7AAh, 1
		jnz		skip_ion_armor		//already done
		test	byte ptr ds:47A794h, 1   //plastic armor done?
		jz		skip_ion_armor
		test	byte ptr ds:47A68Ch, 1	//lobsterman corpse?
		jz		skip_ion_armor
		push 	3Ch		 
		call	unlkresearch
		add		esp, 4
skip_ion_armor:
	}
}

__declspec(naked) void RandomizeShippingLineType()
{
   __asm
   {
	cmp 	ax, 5
	jle 	cargo
	xor		eax,eax
	mov		ax, 13h
   	jmp		end
 cargo:
	xor		eax,eax
	mov		ax, 0Bh
 end:

	ret
    }
}

void TacticalCursorLock()
{
	LockCursor();
	((void (*)())(0x433480))();
}

void TacticalCursorUnlock()
{
	ClipCursor(NULL);
}

void OptionsCursorLock()
{
	ClipCursor(NULL);
	LockCursor();
	((void (*)())(0x417220))();
}

void GeoCursorLock()
{
	LockCursor();
	((void (*)())(0x444DC0))();
}

__declspec(naked) void TankStats()
{
	__asm
	{
		mov		cl, [ebp+2Eh]
		cmp		cl, 2
		jnz		standard
		mov		ecx, 11EAB8h
		shl		ecx, 2    
		mov		cl, byte ptr [ecx]
		cmp		cl, 58h
		jnz		standard
		mov     [ebp+12h], 82h
		mov     [ebp+1Dh], 82h
		mov     [ebp+13h], 5Ah
		mov     [ebp+1Eh], 5Ah
		mov     [ebp+14h], 5Ah
		mov     [ebp+1Fh], 5Ah
		mov     [ebp+15h], 78h
		mov     [ebp+20h], 78h
		mov     [ebp+16h], 5Ah
		mov     [ebp+21h], 5Ah
		mov     cl, [eax+9]
		mov     [ebp+17h], cl
		mov     cl, [ebp+0Ch]
		mov     [ebp+19h], cl
		mov     cl, [ebp+0Dh]
		mov     [ebp+1Ah], cl
		mov     cl, [ebp+0Fh]
		mov     [ebp+1Bh], cl
		mov     cl, [ebp+10h]
		mov     [ebp+1Ch], cl
		jmp		end
	standard:
		mov     cl, [eax+0Ch]
		mov     [ebp+12h], cl
		mov     cl, [eax+0Dh]
		mov     [ebp+13h], cl
		mov     cl, [eax+0Eh]
		mov     [ebp+14h], cl
		mov     cl, [eax+0Fh]
		mov     [ebp+15h], cl
		mov     cl, [eax+10h]
		mov     [ebp+16h], cl
		mov     cl, [eax+9]
		mov     [ebp+17h], cl
		mov     cl, [ebp+0Ch]
		mov     [ebp+19h], cl
		mov     cl, [ebp+0Dh]
		mov     [ebp+1Ah], cl
		mov     cl, [ebp+0Fh]
		mov     [ebp+1Bh], cl
		mov     cl, [ebp+10h]
		mov     [ebp+1Ch], cl
		mov     cl, [eax+0Ch]
		mov     [ebp+1Dh], cl
		mov     cl, [eax+0Dh]
		mov     [ebp+1Eh], cl
		mov     cl, [eax+0Eh]
		mov     [ebp+1Fh], cl
		mov     cl, [eax+0Fh]
		mov     [ebp+20h], cl
		mov     cl, [eax+10h]
		mov     [ebp+21h], cl
	end:
		ret
	}
}

__declspec(naked) void MFGlimitRateFix()
{
	__asm
	{
		mov		ecx, ds:4CB4B0h
		xor		edx, edx 
		mov		edx, [esp+24h] 
		movzx	eax, word ptr ds:0x47AA94[edx]
		mov		dx, ax
		xor 	eax, eax
		movzx	eax, word ptr [ecx+esi*2+0ACh]
		cmp		eax, edx 
		jge		skip
		mov		eax, dword ptr ds:4CB4B0h
		mov 	[esp+1Ch], 1
		inc		word ptr [eax+esi*2+0ACh]
		dec		[esp+48h]
		dec		[esp+44h]
		skip:
		xor		edx, edx
		mov		dx, word ptr ds:478AB4h 
		ret
	}
}

__declspec(naked) void ImpGaussUP1()
{
	__asm
	{
		xor		edx, edx
		cmp     word ptr [ebp+2], 2
		mov		dl, [ebx+0Ch]
		jnz		normal
		mov		dl, 82h
	normal:
		ret
	}
}

__declspec(naked) void ImpGaussUP2()
{
	__asm
	{
		xor		ecx, ecx
		cmp     word ptr [ebp+2], 2
		mov		cl, [ebx+0Dh]
		jnz		normal
		mov		cl, 5Ah
	normal:
		ret
	}
}

__declspec(naked) void ImpGaussUP3()
{
	__asm
	{
		xor		eax, eax
		cmp     word ptr [ebp+2], 2
		mov		al, [ebx+0Eh]
		jnz		normal
		mov		al, 5Ah
	normal:
		ret
	}
}

__declspec(naked) void ImpGaussUP4()
{
	__asm
	{
		xor		edx,edx
		cmp     word ptr [ebp+2], 2
		mov		dl, [ebx+0Fh]
		jnz		normal
		mov		dl, 78h
	normal:
		ret
	}
}

__declspec(naked) void ImpGaussUP5()
{
	__asm
	{
		xor		ecx,ecx
		cmp     word ptr [ebp+2], 2
		mov		cl, [ebx+10h]
		jnz		normal
		mov		cl, 5Ah
	normal:
		ret
	}
}

__declspec(naked) void BlockSiteTooDeep()
{
	__asm
	{
	cmp		[ebp+0], 0
	jnz		end
	mov     esi, [esp+14h]
	push    esi             ; locIdx
	call    SiteTooDeepMsg
	push    esi             ; locIdx
	call    RecallShip
	add     esp, 8
  end:
	ret
	}
}

__declspec(naked) void DeepColony()
{
	__asm
	{
		cmp     di, 4
		jz      toodeep
		xor     ecx, ecx
		mov     cl, byte ptr [eax+1]
		lea     ecx, [eax+eax*4]
		lea     eax, [eax+ecx*2]
		lea     eax, [eax+eax*4]
		cmp     word ptr [edx+eax*2+44h], 3
		jg      toodeep
		mov     ecx, 4605E1h
		jmp     ecx
		toodeep:
		mov     ecx, 4602BBh
		jmp     ecx
	}
}

void RandomNumSave (short seed)
{
	int location=(*(int*)0x4CB490)+12;
	*(short*)location=0;
	short result=GetRandom_0_n(seed);
	*(short*)location=result;
}

__declspec(naked) void BaseRaceMod()
{
	__asm
	{
		mov     edx, dword ptr ds:4CB490h  //loc.dat
		xor     ecx, ecx
		lea     eax, [ebx+ebx*4]
		mov     cl, byte ptr [edx+eax*4+1]
		mov		ax, word ptr [edx+0Ch]
		cmp		al, 28h
		jle		end
		cmp		al, 46h
		jle		tasolth
		mov		cl, 5
		jmp		end
		tasolth:
		mov		cl, 4
		end:
		push	ecx
		push	0Ah
		call	SpawnAlienStuff_asm
		mov		eax, 4527BBh
		jmp		eax
	}
}

__declspec(naked) void Base2RaceMod()
{
	__asm
	{
		xor     ebx, ebx
		xor     eax, eax
		mov     bl, byte ptr ds:4D62CCh
		mov     edx, dword ptr ds:4CB490h
		lea     eax, [ebx+ebx*4]
		shl     eax, 2
		add     edx, eax
		xor     eax, eax
		mov     al, byte ptr [edx+1]
		push    eax
		push    0Fh //0Bh
		call	SpawnAlienStuff_asm
		mov	eax, 452D2Fh
		jmp	eax
	}
}

void StartColonyHook()
{
RandomNumSave(100);
((void (*)())(0x452520))();
}


__declspec(naked) void ArmorMod1()
{
	__asm
	{
		
		cmp		byte ptr ds:48E50Eh, 5  //Is damage type stun?
		jnz		skip
		mov		eax, dword ptr ds:48E290h  //current object's obpos memory offset into eax
		cmp     byte ptr [eax], 1Ah //is current weapon a thermal tazer?
		jz		pierce
skip:
		cmp		byte ptr [esi], 4   //Is this a aquatoid?
		jz		MC
		cmp     word ptr ds:48E50Eh, 0  //Is damage type AP?
		jz		pierce
        //standard model of damage
		mov		eax, dword ptr [esp+14h]  //mov value of current armor at location into eax
		shl		ax, 1
		cmp		cx, ax
		jg		damage
		cmp		byte ptr ds:48E50Eh, 5
		jz		end1
		sub		ax, cx
		sar		ax, 1
		mov		dword ptr [esp+14h], eax
		jmp		end1
pierce:
		mov		eax, dword ptr [esp+14h]  //mov value of current armor at location into eax
		cmp		cx, ax
		jg		damage
		jmp		end1
MC:
		mov		eax, dword ptr [esp+14h]  //mov value of current armor at location into eax
		shl		ax, 1
		cmp		cx, ax
		jg		damage
		mov		eax, 40ED2Dh
		jmp		eax
damage:
		sub		ecx, eax
		mov		eax, 40E91Bh  
		jmp		eax
end1:
		mov		eax, 40ECF2h
		jmp		eax
	}
}

__declspec(naked) void ArmorMod2()
{
	__asm
	{
		cmp	    byte ptr [esi], 4   //Is this an aquatoid?
		jz      skip
		cmp		word ptr ds:48E50Eh, 0  //Is damage AP?
		jnz		noarmor
		movsx   edi, cx
		mov     eax, 51EB851Fh
		or      ebp, 0FFFFFFFFh
		lea     edx, [edi+edi*4]
		shl     edx, 1
		imul    edx
		sar     edx, 5
		mov     eax, edx
		shr     eax, 1Fh
		add     edx, eax
		mov     eax, dword ptr [esp+18h] //ArmorVar
		sub     ebp, edx
		add     eax, ebp
		test    ax, ax
		mov     dword ptr [esp+18h], eax
		jge     here
      noarmor:
		mov		dword ptr [esp+18h], 0
      here:
		mov		edx, 40E96Eh
		jmp		edx
      skip:
		xor     eax,eax
		mov	    edx, 40E96Eh
		jmp	    edx
	}
}

int AutopsyCheck()
{
	int pCurDamUnitPOSref=*(int *)0x4D491C;
	int pCurDamUnitUNITREFref=*(int *)(pCurDamUnitPOSref+4);
	char CurDamUnitType=*(char *)pCurDamUnitUNITREFref;
	if (CurDamUnitType<=3) return 1;
	if (CurDamUnitType==17) return 0;
	if (CurDamUnitType>3 && CurDamUnitType<15)
	{
		char UnitType=CurDamUnitType-=4;
		char UnitAutopsy=*(char*)(0x47A660+(UnitType*22));
		if (UnitAutopsy==1) return 1;
		else return 0;
	}
	else return 0;
}


__declspec(naked) void DamageMod()
{
	__asm
	{
		jge		skip
		mov		dword ptr [esp+18h], 0
	skip:
		cmp		word ptr ds:48E50Eh, 2 //Is it HE damage?
		jz		fulldamage
		mov     eax, dword ptr [esp+10h] //Impact spot
		cmp     al, 1        
		jz		fulldamage   //Hit the "head" or other vital spot.
		call 	AutopsyCheck
		test	al, al
		jnz     fulldamage
		sar     ecx,1
	fulldamage:
		mov		edi, ecx
		mov     edx, 40E96Eh
		jmp     edx
	}
}

__declspec(naked) void StunMod()
{
	__asm
	{
	mov   eax, edi
	cdq
	and   edx, 3
	xor   eax, eax
	add   eax, edx
	ret
	}
}

__declspec(naked) void ModLoadout()
{
	__asm
	{
		mov     dl, byte ptr [edi]
		cmp     word ptr ds:4CB220h, 0  //site depth
		mov     byte ptr [esp+1Ch], dl //CurrentObject variable
		jnz     loc_458014
		cmp     dl, 28h
		jnz     loc_458009
		mov     dl, 22h
		mov     byte ptr [esp+1Ch], dl 
		jmp     loc_458014
		loc_458009:
		cmp     dl, 29h
		jnz     loc_458014
		mov     dl, 23h
		mov     byte ptr [esp+1Ch], dl 
		loc_458014:
		xor		edx, edx
		mov		dl, byte ptr [ebp]
		cmp		dl, 4
		jnz		end //lobsterman
		cmp		byte ptr[ebp+2Ah], 3
		mov		dl, byte ptr [esp+1Ch]
		jge		aquarank
		cmp		dl, 22h
		jnz		ammo
		mov		dl, 24h
		jmp		final
		ammo:
		cmp		dl, 23h
		jnz		final
		mov		dl, 25h
		jmp		final
		aquarank:
		cmp		dl, 22h
		jz		pistol
		cmp		dl, 23h
		jz		ammo1
		cmp		dl, 24h
		jz		pistol
		cmp		dl, 25h
		jz		ammo1
		jmp		end
		pistol:
		mov		dl, 26h
		jmp		final
		ammo1:
		mov		dl, 27h
		jmp		final
/*
lobsterman:
		cmp		dl,6
		jnz		end
		cmp		byte ptr[ebp+2Ah], 1
		jz		disruptor
		cmp		byte ptr[ebp+2Ah], 2
		jnz		end
disruptor:
		cmp     word ptr ds:4CB220h, 0
		jnz		end
		mov		dl, byte ptr [esp+1Ch]
		cmp		dl, 22h
		jnz		ammo3
		mov		dl, 28h
		jmp		final
ammo3:
		cmp		dl, 23h
		jnz		reader
		mov		dl, 29h
		jmp		final
reader:
		cmp		dl, 2Ch
		jnz		end
		mov		dl, 29h */
	final:
		mov		byte ptr [esp+1Ch], dl
	end:
		mov		dl,	byte ptr [esp+1Ch]
		mov		esi, 458014h
		jmp		esi
	}
}

__declspec(naked) void SlowGeoClock1()
{
	__asm
	{
	mov		ax, word ptr ds:4CB494h 
	cmp		ax, 1  //5 secs
	jg		next1
	mov		dword ptr ds:4CCC74h, 25h 
	jmp		done
next1:
	cmp		ax, 2   //1 minute @ 10 second increments
	jg		next2
	mov		dword ptr ds:4CCC74h, 20h
	jmp		done
next2:
	cmp		ax, 0Ch //5 minutes @ 1 minute increments
	jg		next3
	mov		dword ptr ds:4CCC74h, 1Dh
	jmp		done
next3:
	cmp		ax, 3Ch //30 minutes @ 5 minute increments
	jg		next4
	mov		dword ptr ds:4CCC74h, 1Dh 
	jmp		done
next4:
	cmp		ax, 78h //1 hour  @ 10 minute increments
	jg		next5
	mov		dword ptr ds:4CCC74h, 16h 
	jmp		done
next5:
	mov		dword ptr ds:4CCC74h, 10h  //1 day @ 1 hour increments
done: 
	call    GetTime
	sub     eax, [esp+10h]
	mov		edx, dword ptr ds:4CCC74h
	sub		edx, eax //
	cmp		edx, 0
	jle		skip2
	push	edx
	call	Sleep_time
	add		esp,4
skip2:
	mov		esi, 444CE2h
	jmp		esi
	}
}

__declspec(naked) void LargeUnitMCFix()
{
	__asm
	{
		mov		dl, byte ptr ds:48E260h //Current faction var
		mov		ecx, 4A2C40h  //start of UNITPOSref
		xor		esi, esi
findheadloop:               //find the first section or "head" of the large unit selected
		mov		edx, dword ptr [ecx+4]
		cmp		dword ptr [eax+4], edx
		jz		finish
		add		ecx, 0Eh
		inc		esi
		cmp		esi, 50h
		jge		end
		jmp		findheadloop
finish:
		xor		esi, esi
MCloop:  
		mov		edx, dword ptr[ecx+0Ah]
		or      edx, 40h
		mov		dword ptr[ecx+0Ah], edx
		mov		byte ptr [ecx+9], 0
		inc     esi
		cmp		esi, 4
		jge		end
		add     ecx, 0Eh
		jmp		MCloop
end:  
		and     ecx, 0FFh
		and		edx, 0FFh
		mov		esi, 422182h  //or use edx
		jmp		esi
	}
}

__declspec(naked) void LargeUnitExplosionFix()
{
	__asm
	{
		call    Tactical_DoDamageToUnit
		add     esp,8
		xor		ecx, ecx
		xor		edx, edx
		xor		eax, eax
		mov		ecx, dword ptr [edi+9]
		test    ecx, 4
		jz      single
		shl		ecx, 3
		and     ecx, 3
		mov		edx, 3
		sub		edx,ecx
		mov		eax, [esp+14h]
		add		eax, edx
		mov		[esp+14h],eax
		mov		eax, dword ptr [edi+9]
		test    eax, 2
		jnz		skip
		mov		eax, 0FFFFFFFDh
		lea		esi,ds:0[ecx*8]
		sub		esi, ecx
		neg		esi
		mov		ecx, dword ptr [edi+esi*2+9]
		lea		esi, [edi+esi*2-1]
		and		ecx, eax
		mov		dword ptr [esi+0Ah], ecx
		mov		ecx, dword ptr[esi+18h]
		and		ecx, eax
		mov		dword ptr [esi+18h], ecx
		mov		ecx, dword ptr[esi+26h]
		and		ecx, eax
		mov		dword ptr [esi+26h], ecx
		mov		ecx, dword ptr [esi+34h]
		and		ecx, eax
		mov		dword ptr [esi+34h],ecx
	skip:
		lea		esi,ds:0[edx*8]
		sub		esi,edx
		lea		edi,[edi+esi*2]
	single:
		mov		eax, 40D960h
		jmp		eax
	}
}	

__declspec(naked) void ZombieMCFix()
{
	__asm
	{
		//mov     edi, [ebx+0Ah]
		or 		edi, 2
		and		edi, 3
		mov		dl, 1
		//mov     [eax+0Ah], ebx
		mov     [esp+5Ch-9], 0
		mov		ecx, 40986Ch
		jmp		ecx
	}
}


__declspec(naked) void HotGrenade1()
{
	__asm
	{

		cmp     byte ptr [ecx], 16h //high explosive
		jnz		noclock
		push    0
		call    DrawExplosiveTimer
		add     esp, 4
		cmp     ax, 0FFFFh
		jz      skip
		jmp     end
	skip:
		mov		ebx, 42104Dh
		jmp		ebx
	noclock:
		xor		eax, eax
	end:
		mov     word ptr ds:48E280h, 8  //tacitcal status error msg
		mov     cl, byte ptr ds:48E340h  //current tacitcal turn
		mov     edx, dword ptr ds:48E290h  //Current Object OBPOS ref
		add     cl, al
		mov     byte ptr [edx+8], cl
		mov		ebx, 42102Eh
		jmp		ebx
	}
}

__declspec(naked) void HotGrenade2()
{
	__asm
	{
		call	TacticalDrawErrorMessage
		call    UpdateShotsTUs
		mov     edi, dword ptr ds:48E290h
		cmp     byte ptr [edi], 16h
		jz		skip
		push	0A0h
		call	Sleep_time
		add		esp, 4
		call	DetonatePrimedExplosives
	skip:
		mov		edi, 4101E2h
		jmp		edi
	}
}

__declspec(naked) void HotGrenade3()
{
	__asm
	{
		mov     word ptr ds:48E560h, bx // bx=0
		push	050h
		call	Sleep_time
		add		esp, 4
		call	DetonatePrimedExplosives
		mov     ebx, 405519h
		jmp	    ebx
	}
}


__declspec(naked) void ItemDest()
{
	__asm
	{
		mov		ax, word ptr ds:48E50Eh //weapon damage type
		cmp		ax, 2
		jnz		direct
		cmp		byte ptr [esi-4], 22h
		jz      clip
		cmp     byte ptr [esi-4], 24h
		jz      clip
		cmp     byte ptr [esi-4], 26h
		jz      clip
		cmp     byte ptr [esi-4], 28h
		jz      clip
		cmp     byte ptr [esi-4], 2Ah
		jz      clip
		mov		byte ptr [esi-4], 0FFh
		mov		eax, 40F005h
		jmp		eax
	clip: 
			mov		ecx, esi
			sub		ecx, 4D85E4h
			shl		ecx, 4
			mov		edx, 4D85E0h
			xor		eax, eax
		cliploop:
			cmp     word ptr [edx+6], cx
			jz      found
			add     edx, 10h
			inc     eax
			cmp     eax, 0AAh
			jz      skip
			jmp     cliploop
		found:
			mov     byte ptr [edx], 0FFh
	skip:
		mov		byte ptr [esi-4], 0FFh
		mov		eax, 40F005h
		jmp		eax
	direct:
		mov		al, byte ptr [esi-4]
		cmp		al, 22h
		jz		weapon
		cmp		al, 24h
		jz		weapon
		cmp		al, 26h
		jz		weapon
		cmp		al, 28h
		jz		weapon
		cmp		al, 2Ah
		jnz		saved
	weapon:
		push	64
		call	GetRandom_0_n
		add		esp, 4
		mov		cx, word ptr ds:4CC23Eh //game difficulty
		cmp     cx, 6
		jnz     usual
		add     al, 13h
		jmp     skip2
usual:
		shl		cx, 2  //multiply by 4
		add     al, cl
skip2:
		xor		ecx, ecx
		cmp		al, 14h
		jl		saved
		jmp     clip
	saved:
		xor		ecx, ecx
		xor		eax, eax
		mov     byte ptr [esi], 0FFh
		mov     al, [edi]
		mov     [esi-3], al
		mov		edx, 40EFDEh
		jmp		edx
	}
}

__declspec(naked) void BurnItems()
{
	__asm
	{
		mov     al, byte ptr [esi+edx*2+2Ah]
		and     al, 0FFh
		xor     edx, edx
		mov     dl, 3Ch
		sub     edx, eax
		mov	esi, edx
		movsx   edx, byte ptr [ebp-3]
		shl     edx, 2
		add     edx, 2
		push    edx
		call    GetRandom_0_n
		add     esp, 4
		cmp     esi, eax
		jg      skip
		mov     byte ptr [ecx-2], 0FFh
		skip:
		mov     eax, 42E018h
		jmp     eax
	}
}

__declspec(naked) void RecoverClipFix()
{
	__asm
	{
		mov    ecx, 4D85E0h //start of OBPOS.DAT
		mov    cl, byte ptr [ebp+ecx]
		mov	   ebp, 4D85E0h
		and    ecx, 0FFh
		mov    ebx, 0D2h
		xor    eax, eax
		xor    esi, esi
	loopstart:                  //loop to find all object similar to the current ammo object
		cmp    byte ptr [ebp], 0FFh
		jz     skip
		cmp    byte ptr [ebp], cl
		jnz    skip
		movsx  eax, byte ptr [ebp+8]   //adds the amount to the total amount
		add    esi, eax
		mov    byte ptr [ebp], 0FFh
	skip:
		dec    ebx
		test   bx, bx
		jz     end
		add    ebp, 10h
		jmp    loopstart
	end:
		movsx  bx, byte ptr [edi+26h]  //gets the ammo size for this clip from OBDATA.DAT
		mov    eax, esi
		mov    esi, edx
		xor    edx, edx
		div    bx                    //divides the total rounds by full clip size, dropping any remainder
		mov    edx, esi
		mov    si, word ptr [edx]
		add    si, ax
		mov    word ptr [edx], si       //adds the clips to the current BASE.DAT field					
		mov    ebp, [esp+10h]           //sets ebp back to current obpos offset
		and    ebx, 0FFFFh
		mov    eax, 44C0BAh
		jmp    eax
	}
}

__declspec(naked) void BezerkCrashFix()
{
	__asm
	{
			push    2
			call    GetRandom_0_n
			add     esp, 4
			inc     al
			cmp     al, 3
			jnz     skip
			cmp     byte ptr [esi+75h], 0FFh
			jz      skip
			mov     al, 2
			skip:
			mov     edi, 42243Dh
			jmp     edi
	}
}

__declspec(naked) void TentacultIgnoreTank()
{
	__asm
	{
		mov   eax, dword ptr ds:4D6268h  //current unit unitref offset
		cmp   byte ptr [eax], 0Bh
		jnz   usual
		mov   al, byte ptr [esi+9]
		test  al, 4
		jnz   skip
		usual:
		mov   al, byte ptr [esi+8]
		mov   cl, byte ptr ds:48E260h //Current Active Faction
		cmp   al, cl
		jz    skip
		mov   ecx, 403B0Dh
		jmp   ecx		
		skip:
		mov   ecx, 403C95h
		jmp   ecx
	}
}

__declspec(naked) void TentacultVictimYell()
{
	__asm
	{
		mov     byte ptr [ecx+70h], 1
		cmp     word ptr ds:48DC5Eh, 0
		jz      skip
		mov     word ptr ds:48DC5Eh, 0
		push    0A0h
		push    3Fh
		push    6Dh
		call    BattleSoundCall
		push    0F0h
		call    Tac_sleep
		add     esp, 10h
		skip:
		mov     ebx, 40698Ah
		jmp     ebx
	}
}

__declspec(naked) void FireFix()
{
	__asm
	{
		movsx   eax, byte ptr [ebp-3]
		xor		edx, edx
		movsx   dx, byte ptr [esi+37h]
		mov     dx, word ptr ds:4781D8h[edx*2]
		test    dx, dx
		jz      end
		movsx   ecx, byte ptr[esi+0Dh]
		movsx   edi, dx
		imul    eax, edi
		mov     edx, eax
		mov     eax, 51EB851Fh
		imul    edx
		sar     edx, 5
		mov     eax, edx
		shr     eax, 1Fh
		add     edx, eax
		cmp     ecx, edx
		jg		damage
		mov     byte ptr [esi+0Dh], 0
		push    edi
		call    Tactical_KillUnit
		add     esp, 4
		jmp     end
	damage:
		sub     cl, dl
		mov     [esi+0Dh], cl
		cmp     byte ptr [esi], 11h
		jnz     skip
		inc     word ptr [ebx+2]  //increase timer count
		cmp     byte ptr ds:48E260h, 0
		jnz     skip
		inc     word ptr [ebx+2]
	skip:
		push    64h
		call    GetRandom_0_n
		mov     dx, ax
		lea     ecx, [edi+edi*4]
		and     edx, 0FFFFh
		mov     eax, 51EB851Fh
		shl     ecx, 3
		mov     [esp+28h-8], edx
		imul    ecx
		mov     eax, [esp+28h-8]
		add     esp, 4
		sar     edx, 5
		mov     ecx, edx
		shr     ecx, 1Fh
		add     edx, ecx
		cmp     eax, edx
		jge     end
		//mov     ecx, [esp+14h] //UNIPOSunitCounter
		//push    ecx
		push    ebx       //currentUnitPOSidx  new code
		call    SetUnitOnFire
		add     esp, 4
	end:
		mov     edi, 42DE3Ch
		jmp     edi
	}
}

__declspec(naked) void SetMeleeAttackFix()
{
	__asm
	{
		cmp    al, 0Dh
		jz     melee
		cmp    al, 6
		jz     melee
		cmp    al, 8
		jz     melee
		cmp    al, 11h
		jz     melee
		cmp    al, 0Ah
		jz     melee
		cmp    al, 0Ch
		jz     melee
		cmp    al, 0Bh
		jz     melee
		//start search function ***********
		mov     ebx, dword ptr ds:4D6338h  //OBDATA
		mov     edx, 4D85E0h  //OBPOSDAT
		xor     eax, eax
	loc_404FF3:                             
		mov     cl, byte ptr [edx]
		cmp     cl, 0FFh
		jz      loc_405018
		movsx   bp, byte ptr [edx+4]
		cmp     bp, word ptr ds:48E27Eh //currentUnitIDx
		jnz     loc_405018
		xor     ebp, ebp
		cmp     cl, 1Ch                               //Vibroblade
		jz      done //     loc_405018		           
		cmp     cl, 1Dh                               //thermal lance 
		jz      done
		cmp     cl, 1Eh                              //heavy thermal lance
		jz      done //jg      loc_405018
	loc_405018:                             
		inc     eax
		add     edx, 10h
		cmp     ax, 0D2h
		jl      loc_404FF3                        
		//end search function****************
		mov     word ptr ds:48DB20h, 0
		xor     ebx, ebx
		jmp     end
	done:
		xor     ebx, ebx
		mov		ebp, 1                          
		mov     word ptr ds:48DB20h, bp
		jmp     norange
	melee:
		mov    word ptr ds:48DB20h, bp  //canmelee =1
    end:
		mov    al, byte ptr [esi]
		cmp    al, 8
		jmp    norange
		cmp    al, 0Bh
		jmp    norange
		cmp    al, 11h
		jnz    skip
	norange:
		mov    word ptr ds:48DB22h, di  //canrangeattack =0
	skip:
		mov    eax, 40160Fh
		jmp    eax
	}
}

__declspec(naked) void BaseDefensePrep()
{
	__asm
	{
		mov     edx, dword ptr ds:4CB490h
		mov     ecx, [esp+38h] //curlocLOCDATmemadd
		xor     eax, eax
		xor     esi, esi
		mov     al, byte ptr [ecx+edx+1]
		mov     dword ptr [esp+10h], 32h //counter
		lea     ecx, [eax+eax*8]
		lea     eax, [eax+ecx*4]
		mov     ecx, dword ptr ds:4CB4B8h //pBASEDAToffset4CB4B8
		lea     edi, [ecx+eax*8]
		mov     [esp+18h], edi  //base_ref
		locloopstart:
		cmp     byte ptr [esi+edx], 2
		jnz     skip
		xor     eax, eax
		mov     al, byte ptr [esi+edx+1]
		lea     ecx, [eax+eax*4]
		lea     eax, [eax+ecx*2]
		mov     ecx, dword ptr ds:4CB4F8h //pCraftDat_4CB4F8
		lea     eax, [eax+eax*4]
		lea     eax, [ecx+eax*2]
		mov     cx, word ptr [eax+52h]
		cmp     cx, word ptr [esp+50h] //curlocLOCDATidx
		jnz     skip
		mov     cx, word ptr [eax+62h]
		cmp     cx, 1
		jz      skip
		cmp     cx, 0FFFFh
		jz      skip
		lea     ecx, [eax+6]
		lea     eax, [edi+24h]
		mov     edx, 37h
		invloopstart:
		movzx   bx, byte ptr [ecx]
		mov		byte ptr [ecx], 0
		add     word ptr [eax], bx
		add     eax, 2
		inc     ecx
		dec     edx
		jnz     invloopstart
		mov     edx, dword ptr ds:4CB490h //pLOCDAT_4CB490
		skip:
		mov     eax, dword ptr [esp+10h] //counter
		add     esi, 14h
		dec     eax
		mov     dword ptr[esp+10h], eax //counter
		jnz     locloopstart
		movsx   ebx, word ptr [esp+50h] //curlocLOCDATidx
		push    2
		call    LoadGeodataPalette
		push    2
		call    LoadGeodataBackPalette
		push    1
		call    LoadGeodataBackPalette
		add     esp, 0Ch
		push    ebx
		call    ShowBaseEditor
		add     esp, 4
		push    5
		call    LoadGeodataBackPalette
		add     esp, 4
		//push    ebx
		//call    SellMenu
		//add     esp, 4
		mov     ebx, 456D23h
		jmp     ebx
	}
}

void BaseDefenseHook (short basenum, int locnum)
{
int basename=*(int*)0x4CB4B8+(basenum*296);
SoundCall(0x8E,0x3F,0xA0);
LoadGeographBackScreen(1);
LoadGeodataBackPalette(5);
DrawDialogBox(0,0,0xC8,0x140,2);
DrawString2(*(int*)0x4AB0A8,2,0x18,0x10,0);
DrawString2(*(int*)0x4AB0AC,2,0x28,0x10,0);
DrawString2(basename,2,0x28,0xFFFFFFFF,0);
*(short *)0x48E348=0x120;
DrawString2(*(int*)0x4AB0B0,2,0x40,0x10,1);
CreateButton2(0xA4,0x64,0x12,0x78,2,*(int*)0x4AAE14);
UNK_SomeDrawingFunctionB(1);
WaitTillMouseButtonsAreReleased();
while(!CheckForClickedButton());
((void (*)(short, int))(0x452230))(basenum, locnum);
}

/*
void CreateInitialAlienBases(__int16 isInitialBase)
{
	CreateXComBase(1);
	int nBases=INI_READ_INT("Mod","Initial Alien Bases",0);
	for(int i=0;i<nBases;i++)
	{
		unsigned char race=GetRandom_0_n(4);
		unsigned char zone=GetRandom_0_n(11);
		CreateAlienBase(zone,race);
	}
}

*/

/*
int HasSoldierFought(__int16 soldierIdx)
{
	unsigned char *unitpos=(unsigned char *)0x4A2C40;

	for(int i=0;i<80;i++,unitpos+=14)
	{
		if(unitpos[0]==0xff)
			continue;
//		unitref_dat *unitref=*(unitref_dat **)&unitpos[4];
		unitref_dat *unitref=&((*file_missdat_uniref_dat)[i]);
		if(unitref->soldier_index==soldierIdx)
			return 1;
	}
	return 0;
}

int GetScoreForPromotion(__int16 soldierIdx)
{
	int score=0xffffffff;
	if(HasSoldierFought(soldierIdx))
		score=GetSoldierScoreForPromotion(soldierIdx);

	return score;
}

*/

/*
__declspec(naked) void DisableSoldierPurchase(void)
{
	__asm
	{
		mov ecx, 0x470762+0x14
		mov eax,1
		ret
	}
}

*/
//.text:00448E22 A1 6C 3F 4A 00                mov     eax, carretPosition
//.text:00448E27 8B 4F 0A                      mov     ecx, [edi+0Ah]

/*
__declspec(naked) void IncomeOnlyItemPrice(void)
{
	__asm
	{
		mov eax, 0x4A3F6C
		mov eax, [eax]
		mov ecx, [edi+0xA]
		cmp byte ptr [edi+18],1
		jz purchaseable
		xor ecx,ecx
purchaseable:
		ret
	}
}

//.text:004489AE 8B 90 5A 07 47 00             mov     edx, [eax+47075Ah] //sell price (+8 for purchaseable)

__declspec(naked) void IncomeOnlyItemPrice2(void)
{
	__asm
	{
		mov dl, [eax+0x47075A+8] //purchaseability
		cmp dl, 1
		mov edx, [eax+0x47075A] //sell price
		jz purchaseable
		xor edx,edx
purchaseable:
		ret
	}
}

//.text:0044892B 8B 96 5A 07 47 00             mov     edx, purchaseInfo.sellPrice[esi]
__declspec(naked) void IncomeOnlyItemPrice3(void)
{
	__asm
	{
		mov dl, [esi+0x47075A+8] //purchaseability
		cmp dl, 1
		mov edx, [esi+0x47075A] //sell price
		jz purchaseable
		xor edx,edx
purchaseable:
		ret
	}
}
/*
unsigned char *fogMap=NULL;

void Fog(short a, short b, unsigned int c, unsigned int d)
{
	((void (*)(int,int,int,int))(0x430950))(a,b,c,d);

	if(!fogMap)
		return;

	unsigned char *pSeeMapCurrentTile=*(unsigned char **)0x49DB08;

	int offset=pSeeMapCurrentTile-*pSeeMap;
	unsigned char *pFogMap=fogMap+offset;

	FILE *log=fopen("C:/log.txt","a+");
//	if(*pSeeMapCurrentTile!=0&&*pSeeMapCurrentTile!=7)
//	fprintf(log,"0x%08x 0x%08x\n",pSeeMapCurrentTile,*pSeeMapCurrentTile);
	char *buf=*BackBuffer+a+320*b;

	if(*pFogMap!=*pSeeMapCurrentTile)
	{
		//fprintf(log,"0x%08x 0x%08x\n",a,b);
		//*pSeeMapCurrentTile&=~1;
		for(int i=0;i<32;i++)
		{
			if(i+a>=320)
				continue;
			if(i+a<0)
				continue;

			for(int j=0;j<40;j++)
			{
				if(j+b>=*(int *)0x4A2848)
					continue;
				if(j+b+40<*(int *)0x4A2826)
					continue;
				
				int offset=i+a+(j+b)*320;
				if(offset>=0&&offset<64000)
					if((i+j)&1)
						*(buf+i+j*320)=0;
			}
		}
	}
	fclose(log);
}

void UpdateFogMap()
{
	int size=*map_numTilesPerLevel**tac_mapZSize;
	fogMap=(unsigned char *)realloc(fogMap,size);

	for(int i=0;i<size;i++)
	{
		fogMap[i]=(*pSeeMap)[i]|0x10;
	}
}

void ClearSeeMap()
{
	int size=*map_numTilesPerLevel**tac_mapZSize;
if(fogMap)
	for(int i=0;i<size;i++)
	{
		(*pSeeMap)[i]=0;
	}
}

void UpdateSeeMap()
{
	int size=*map_numTilesPerLevel**tac_mapZSize;
if(fogMap)
	for(int i=0;i<size;i++)
	{
		if((*pSeeMap)[i]!=0)
		{
			fogMap[i]=(*pSeeMap)[i];
		}
		else
		{
			(*pSeeMap)[i]=fogMap[i]&0x7;
		}
	}
}

//.text:0042DD87 E8 44 00 00 00                call    UpdateSeeMap
void HookSeeMap(int xpos, int ypos, __int16 zpos, int facing, int distance)
{
	ClearSeeMap();
	((void (*)(int,int,__int16,int,int))(0x42DDD0))(xpos,ypos,zpos,facing,distance);
	UpdateSeeMap();
}




//.text:0042A703 38 1D D8 B6 46 00             cmp     byte_46B6D8, bl
__declspec(naked) void FixSeeMap(void)
{
	__asm
	{
		pusha
		call UpdateSeeMap
		popa
		mov ebx, 0x46B6D8
		cmp[ebx],0
		mov ebx,0
		ret
	}
}
*/

/*
.text:00418780                               ; int __cdecl TacticalComputeSoldiersLightSources()
.text:00425940                               ; int __cdecl TacticalDrawMap_sub_425940()
.text:0042EA40                               ; int __cdecl ComputeVisibleAliens(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)
.text:00420D61 E8 DA DC 00 00                call    ComputeVisibleAliens
*/
/*
void UpdateTerrain(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)
{
	ComputeVisibleAliens(xpos, ypos, zpos, orientation, distance);
	TacticalComputeSoldiersLightSources();
	UpdateSeeMapAndVisibleEnemies();
	((void (*)())0x425940)();
/*
	mov     eax, BackBuffer
lea     ecx, [eax+0B400h]
push    ecx
push    eax
push    1
call    _sub_4302A0
*
	((void (*)(int,char *,char *))0x4302A0)(1,*BackBuffer+0xB400,*BackBuffer);
}



/*
__int64 freq = -1;




/*
char ShowCraftReadyBotitle[64];
char ShowCraftReadyBoinfo[64];
void ShowCraftReadyBoStrings()
{
	static int init = 0;

	if(init == 1)
		return;

	INI_READ_STRING("Craft Ready Message","Title","Aircraft ready",ShowCraftReadyBotitle,63);
	INI_READ_STRING("Craft Ready Message","Info","A craft has been refitted",ShowCraftReadyBoinfo,63);

	init = 1;
}

void ShowCraftReadyBoImpl(unsigned char *pCraft)
{
	char craftName[64]="Unknown craft";
	const char *craftType=StringTable_geoscape[0x239+pCraft[0]];
	unsigned char baseLoc = pCraft[26];
	unsigned char baseIdx=(*locationList+20*baseLoc)[1];
	char *baseName=(char *)&(*pBaseList+292*baseIdx)[0];
	unsigned char craftIdx=(pCraft-*craftList)/104;

	for(unsigned char i=0;i<50;i++)
	{
		unsigned char type=(*locationList+20*i)[0];
		if(type!=2)
			continue;
		unsigned char craftRef=(*locationList+20*i)[1];
		if(craftRef==craftIdx)
		{
			unsigned short suffix=(*locationList+20*i)[0xa];
			sprintf(craftName,"%s-%d",craftType,suffix);
			break;
		}
	}

	ShowCraftReadyBoStrings();

	(*geo_num_rearming_crafts)--;

	//Craft background
	LoadGeographBackScreen(14);
	LoadGeodataBackPalette(4);

	//Draw box
	((void (*)(int,int,int,int,int,int,int,int,int,int))(0x43D8C0))(0x5a,0x70,0x14,0x20,0x30,0x18,0x78,0xD0,0x14,0x86);

	DrawString(ShowCraftReadyBotitle,0x86,0x38,0x30,0);
	DrawString(ShowCraftReadyBoinfo,0x86,0x48,0x30,1);

	DrawString(StringTable_geoscape[0x109],0x86,0x52+6,0x30,1); //CRAFT
	DrawDottedLine(0x86,0x82+6,1);
	DrawString(craftName,0x8B,0x52+6,0x82,1);

	DrawString(StringTable_geoscape[0x10B],0x86,0x5a+6,0x30,1); //BASE
	DrawDottedLine(0x86,0x82+6,1);
	DrawString(baseName,0x8B,0x5a+6,0x82,1);
/*
	DrawString(roswel_terrain,0x86,0x62,0x30,1);
	DrawDottedLine(0x86,0x82,1);
	DrawString(terrain,0x8B,0x62,0x82,1);
*-
	*ui_numButtons=0;

	//"Centre + 5sec" button
	CreateButton(0x80,0x30,0x0C,0xA0,0x86,StringTable_geoscape[48]);

	//Cancel
	CreateButton(0x90,0x30,0x0C,0xA0,0x86,StringTable_geoscape[49]);

	((void (*)(int))(0x42F680))(1);

	WaitTillMouseButtonsAreReleased();
	int button;
	while(!(button=CheckForClickedButton()));

	*ui_numButtons=0;


	if(button==1)
	{
		*geo_timeSpeed=1;
		RotateGlobeToLocation(baseLoc);
	}
}

__declspec(naked) void ShowCraftReadyBox()
{
	__asm {
		pusha
		push esi
		call ShowCraftReadyBoImpl
		pop esi
		popa
		ret
	}
}

*/

/*
 * Detect successful ground assault missions and trigger reaction from alien
 *
void RetaliationAfterGroundAssault(void *dstbuf, int filename)
{
	char victoryStatus;
	LoadFile(dstbuf,filename);
	victoryStatus=tac_misdata[0x4e];

	if(victoryStatus == 1) //mission successful
	{
		char locIdx=tac_misdata[0x4c];
		if( ((*locationList+20*locIdx))[0] == 1 ) //Landed UFO have type 1 here, not 6!!!
		{
			char ufoIdx=(*locationList+20*locIdx)[1];
			char craftIdx=tac_misdata[0x4d];
			void *attacker=(void *)(*craftList+104*craftIdx);
			void *ufo=(void *)(*craftList+104*ufoIdx);
			AlienTakeActionAfterShootDown(ufo,attacker);
		}
	}
}
*/


/*
 * Apply patches according to the ini file
 */
void ApplyPatches()
{
	FreeConsole();
	AllocConsole();
	freopen("CON", "w", stdout);
	
	{
		InsertCall(0x451A97,ShowLoader);
		InsertCall(0x44F406,ShowMod);
		Nop(0x450E1D,7);  //bytes that are hard set when a game loads...unnecessary and causes problems
		Nop(0x450E2F,5);
		Nop(0x450E38,6);
		Nop(0x450E43,6);  //removes the line that sets byte for the aqua plastics research type to zero when you load a game.
		Nop(0x428562,9);  //removes the code that sets the zombie's move sound ref to 18h
		//Nop(0x41F1D8,5);  //removes the loop in the spawn unit subroutine: now same as EU.
	}

/////////////////Enhancements///////////////////
	
	if(INI_READ_INT("Mod","Alien Inventory",0)) 
	{
		Nop(0x413BC0,8); 
	}

	if(INI_READ_INT("Mod","Use All Items On Land",0)) 
	{   //Allow underwater weapons and underwater tank weapons to be used above water.
		char zip[]={0};
		PatchInPlace(0x475674,zip,1);  //Sets the byte in the Depth-to-use database to null for all underwater things.
		PatchInPlace(0x475676,zip,1);
		PatchInPlace(0x475678,zip,1);
		PatchInPlace(0x47567A,zip,1);
		PatchInPlace(0x47567C,zip,1);
		PatchInPlace(0x47567E,zip,1);
		PatchInPlace(0x475680,zip,1);
		PatchInPlace(0x475682,zip,1);
		PatchInPlace(0x475692,zip,1);
		PatchInPlace(0x475696,zip,1);
		PatchInPlace(0x4756B4,zip,1);
		PatchInPlace(0x4756B6,zip,1); //Set the byte in the Depth-to-use database to null for all underwater things.
		PatchInPlace(0x40DA0D,zip,1); //Makes tanks aimed-shots work on land.
		PatchInPlace(0x40F65D,zip,1); //tanks when targeting.
		//PatchInPlace(0x42AB11,zip,1); //PWT tank can fire on land.
		Nop(0x457158,30);   // Allows Mag Ion armor to be used on land
		//below allows you to set waypoints for PWT on land.
		Nop(0x42AACE,5);
		Nop(0x42AADF,52);
		char jump1[]={0xEB};
		PatchInPlace(0x42AB13,jump1,1);

	}

	if(INI_READ_INT("Mod","Doubleclick Movement",0))
	{
		InsertCall(0x423343, CheckIfClickedOnUnit);
		Nop(0x423351,16); //Nop out a few instructions to make the return codes work properly.
	}
	
	if(INI_READ_INT("Mod","Show Money",0))
	{
		ShowMoney();
	}

	if(INI_READ_INT("Video","D3D",0) && INI_READ_INT("Video","D3D Windowed",0))
	{
		InsertCall(0x4674A2,MyRegisterClassA);  //.text:0045DDF2 FF 15 4C 91 46 00             call    ds:RegisterClassA
		Nop(0x4674A2+5);
		InsertCall(0x4674D6,MyCreateWindowExA); //.text:0045DE27 FF 15 2C 91 46 00             call    ds:CreateWindowExA
		Nop(0x4674D6+5);
		Nop(0x467507,14); 
	}

#ifdef NDEBUG
	if(INI_READ_INT("Video","D3D",0) || INI_READ_INT("Video","HQ4x",0) || INI_READ_INT("Video","Video Pitch",0))
#endif
	{
#ifdef NDEBUG
		if(INI_READ_INT("Video","D3D",0))
		{
			if(INI_READ_INT("Video","HQ4x",0))
				SetScalingMethod(4);
			else
				SetScalingMethod(3);
		}
		else if(INI_READ_INT("Video","HQ4x",0))
			SetScalingMethod(2);
		else if(INI_READ_INT("Video","Video Pitch",0))
			SetScalingMethod(1);
#endif
	}

	if(INI_READ_INT("Video","Force Language",0))
	{
		InsertCall(0x44E52E,ForceLanguage);
	}
	
#ifdef NDEBUG
	if(INI_READ_INT("Video","Skip Intro",0))
#endif
	{
		Nop(0x44E5AD,5); 
		Nop(0x44E60D,5);
	}
	
	//Please note that the music patch currently only works with MP3s, and seems to crash on some systems.
	if(INI_READ_INT("Music","Apply",0)) 
	{
		ModMusic();
	}
	//CD/mp3 music do not have the freeze bug. The 2 patches would not work together anyway...
	else if(INI_READ_INT("Bug Fix","Music Change Freeze",1))
	{
		ClickPauseBug();
	}
	
	if(INI_READ_INT("Mod","No Alien Freak Out Messages",0))
	{
		InsertCall(0x4226DF,MyTacticalDrawPanicMessage); //.text:004226DF E8 BC 04 00 00                call    TacticalDrawPanicMessage
		InsertCall(0x422875,MyTacticalDrawPanicMessage); //.text:00422875 E8 26 03 00 00                call    TacticalDrawPanicMessage
		InsertCall(0x42265F,MyTacticalDrawPanicMessage); //.text:0042265F E8 3C 05 00 00                call    TacticalDrawPanicMessage

		InsertCall(0x42278F,MyTactivalViewPosPanic);
		InsertCall(0x422B10,MyTactivalViewPosPanic);
		InsertCall(0x422C7C,MyTactivalViewPosPanic);
	}

	if(INI_READ_INT("Mod","Alien Bleeding",0))
	{

		//.text:0040E1AB 8A 48 09                      mov     cl, [eax+structUnitPos.owner]
		//.text:0040E1AE 84 C9                         test    cl, cl
		InsertCall(0x40EB29, WoundCheck);
		Nop(0x40EB2E,3);
		//char patch[]={0xC0, 0x85, 0x4D};
		//PatchInPlace(0x40E832,patch,3);
		//.text:0040E1B0 0F 85 04 01 00 00             jnz     loc_40E2BA
		//Nop(0x40E1B0,6);
		//Verbose death
		//.text:00413590 0F 85 92 00 00 00             jnz     continue
		//Nop(0x413590,6);
		//.text:0041326D 0F 85 98 00 00 00             jnz     loc_41330B
		//Nop(0x41326D,6);
	}

	//.text:004129FC 38 1D E4 83 47 00             cmp     isDuringReactionFire, bl        ; case 0x4

	if(0)
	{
		Nop(0x413B9C); //0x4129FC
		InsertCall(0x413B9C + 1, CheckMainState); //0x4129FC + 1
	}

	
	if(INI_READ_INT("OBDATA.DAT","Apply",0))
	{
		EnableObDataPatching();
	}

	if(INI_READ_INT("Initial Base","Apply",0))
	{
		SafeBaseDesign();
	}

	if(INI_READ_INT("Line Of Fire Check","Mind Control",0))
	{
		InsertCall(0x421EB2,CheckMindControl);  //.text:0041EE52 E8 99 13 00 00                call    CheckIfClickedOnUnit
	}
	if(INI_READ_INT("Line Of Fire Check","Panic",0))
	{
		InsertCall(0x4221F2,CheckMindControl); //		.text:0041F132 E8 B9 10 00 00                call    CheckIfClickedOnUnit
	}
	if(INI_READ_INT("Line Of Fire Check","Mind Probe",0))
	{
		InsertCall(0x422E90,CheckMindControl);  //		.text:0041FD50 E8 9B 04 00 00                call    CheckIfClickedOnUnit
	}

	//move soldiers in ship
	if(INI_READ_INT("Mod","Reorder Soldiers In Crafts",0))
	{
		InsertCall(0x45E679,CrewDlgAddUpDownButton);  //.text:00455EFD E8 9E A2 FF FF                call    DrawString
		InsertCall(0x45E481,CrewHook);  //.text:00455CEE E8 AD 7B FE FF                call    WaitTillMouseButtonsAreReleased
	}

	if(INI_READ_INT("Mod","De-equip Crafts",0))
	{
		char cancelButtonWidth[]={0x46};
		PatchInPlace(0x45F61F,cancelButtonWidth,1);  
		InsertCall(0x45F62B,CreateCraftDeequipButton); 
//		.text:004569C1 0F 84 7F 01 00 00             jz      exit
		InsertJnz(0x45F281,ExitCraftArmament); 
	}

	if(INI_READ_INT("Range Based Accuracy","Apply",0))
	{
		InsertCall(0x42A43B,DrawAccuracy); 
		Nop(0x42A440,2); 
		InsertCall(0x42A46E,DrawPCKSpriteCursorHook);  
		InsertCall(0x40DD31,RangeBasedAccuracy); //aimed/snap shot
		InsertCall(0x40F856,RangeBasedAccuracy);  //autoshot
		InsertCall(0x411190,ReactionFireAccuracy); //reaction fire
		LoadAccuracyParameters();
	}

	//crafts always ready
	if(INI_READ_INT("Mod","Craft Ready State",0))
	{
		if(INI_READ_INT("Mod","Craft Ready State",0)==1)  //Always ready
		{
			char patch[]={0x50,0x03,0x7C};  //Check fuel level instead of state
			PatchInPlace(0x459CF5,patch,3);
		}
		if(INI_READ_INT("Mod","Craft Ready State",0)==2)  //Grounded for Repairs
		{
			char patch[]={0x02,0x74};
			PatchInPlace(0x459CF6,patch,2);
		}			
	}

	if(INI_READ_INT("Mod","No Blaster Bomb Drift",0))
	{
		Nop(0x42AD61,5); //0x426E78
		Nop(0x405A6F,5); //0x40595F
	}
	else if(INI_READ_INT("Bug Fix","Collectors Edition Blaster Bomb Bug",1))
	{
		InsertCall(0x42AD61,FixedAccuracyCompensation);  //0x426E78
		InsertCall(0x405A6F,FixedAccuracyCompensation);  //0x40595F
	}


	if(INI_READ_INT("Mod","More Reaction Fire",0))
	{
		InsertCall(0x424BFB,ReactionFire1); 
		InsertCall(0x424BF1,ReactionFire2); 
	}

	if (INI_READ_INT("Video","Clip Cursor",0))
	{
		if (INI_READ_INT("Video","Clip Cursor",0)==1)
		{
			InsertCall(0x42E762, TacticalCursorLock);
			InsertCall(0x41AE3A, TacticalCursorUnlock);
			if(INI_READ_INT("Battlescape Shortcuts","Apply",0)==0) {InsertCall(0x413D7D,ShowTacOptionScreen);}
		}
		if (INI_READ_INT("Video","Clip Cursor",0)==2)
		{
			if(INI_READ_INT("Mod","Show Money",0)==0) {InsertCall(0x4445AC, GeoCursorLock);}
			InsertCall(0x42E762, TacticalCursorLock);
			if(INI_READ_INT("Battlescape Shortcuts","Apply",0)==0) {InsertCall(0x413D7D,ShowTacOptionScreen);}
		}
	}
	
	if(INI_READ_INT("Mod","Manual Interception Fire Mode",0))
	{
		Nop(0x44AD0B,2); 
		Nop(0x44AC92,6); 
		Nop(0x44B2E7,13); //dont fallback on taking damage
	}

	if(INI_READ_INT("Mod","USO Responds to Interception",0))
	{
		InsertCall(0x44AD8C,UFOresponse);
		Nop(0x44AD91,2);
		Nop(0x449EA1,3); // sub dx,cx  (base USO escape time-(diff*30))
		InsertCall(0x44ACEB,UFOdelta);
		Nop(0x44ACF0,18);
		//char speed[]={0xFA};
		//PatchInPlace(0x44AC53,speed,1); //increase closing delta to reflect an aggressive USO
		//PatchInPlace(0x44ACED,speed,1);
		InsertCall(0x44B2B6,Adjust_UFOdamage); //0x4470F1
		Nop(0x44B2BB,10); //0x4470F6
	}

	if(INI_READ_INT("Mod","True Cautious Mode",0))
	{
		InsertCall(0x44AACF,AdjustCautiousMode);
		Nop(0x44AAD4,1);
		InsertCall(0x44AD48,CautiousRangeSelect);
		Nop(0x44AD4D,21);
	}

	if(INI_READ_INT("Mod","All torpedos at start",0)) 
	{
        char patch[]={0x03}; 
		PatchInPlace(0x43F152,patch,1); //set ammo amount for DUP torpedoes
		char patch2[]={0x01};  	
		PatchInPlace(0x43F159,patch2,1); //set r-slot as DUP torpedo launcher,sub1
		PatchInPlace(0x43F18C,patch2,1); //set r-slot as DUP torpedo launcher,sub2
		char patch3[]={0x00,0x00,0x00};  
		PatchInPlace(0x4798BA,patch3,3); //remove cannon and DUP launchers in base store
		char patch4[]={0x00};      	
		PatchInPlace(0x4798C8,patch4,1); //remove cannon rounds in base store
		char patch5[]={0x13};	 //extra DUP torpedos for diff in prices
		PatchInPlace(0x4798C6,patch5,1);
	}

	if(INI_READ_INT("Mod","Remove Background Land Sound",0))
	{
		Nop(0x467391,11);
		char patch[]={0x04};
		PatchInPlace(0x46739E,patch,1);
		if(INI_READ_INT("Mod","Remove Background Land Sound",0)>1)
		{ 
			Nop(0x42E6A2,5); //removes all background land sounds
		}
	}
	if(INI_READ_INT("Mod","Block Intercept Over Land Message",0) || INI_READ_INT("Mod","Block Mission Too Deep Message",0) || INI_READ_INT("Mod","Block Can't Intercept Messages",0))
	{
		char jump[]={0xEB};
		char longjump[]={0xE9};
		Nop(0x463557,3);
		Nop(0x463562,379);
		Nop(0x4605C0,3);    //removes the check for barracuda in regards to "site too deep"
		PatchInPlace(0x4605C3,jump,1);
		InsertCall(0x4602BB,BlockSiteTooDeep);
		Nop(0x4602C0,14); 
	}
	if(INI_READ_INT("Mod","Increase Sea Floor Terrain Variety",0))
	{
		char sea1[]={0x8};
		PatchInPlace(0x451DA9,sea1,1);
		char sea2[]={0xF8};
		PatchInPlace(0x451DBE,sea2,1);
		char sea3[]={0xEB,0x23};
		PatchInPlace(0x451DC5,sea3,2);
		char sea4[]={0xEB,0x32};
		PatchInPlace(0x451E55,sea4,2);
	}
	
	if(INI_READ_INT("Enhanced Tactical AI","Apply",0))
	{
		static int maauto_range;
		static int masnap_range;
		char Hmaauto[2];
		char Hmasnap[2];
		maauto_range=INI_READ_INT("Enhanced Tactical AI","Autofire Distance",8);
		masnap_range=INI_READ_INT("Enhanced Tactical AI","Snap Distance",16);
		itoa(maauto_range,Hmaauto,16); 
		itoa(masnap_range,Hmasnap,16);
		PatchInPlace(0x42FBAC,Hmaauto,1);  //0x42BD80
		PatchInPlace(0x42FBC4,Hmasnap,1);  //0x42BD98
		tacticalAIpatch();
	}


#ifdef NDEBUG
	if(INI_READ_INT("Equipment Screen","Show Stats",0)) 
#endif
	{
		//Patch coordinates of "TUs>" string
		char patchy[]={ 0x18+8 };
		char patchx[]={ 0xFA-5 };
		PatchInPlace(0x41B131,patchy,1); 
		PatchInPlace(0x41B12C,patchx,1); 
		InsertJmp(0x41BA42,ShowEncumberance); 
	}

#ifdef EQUIPMENT
	void SaveEquipment();
	void InitNewGeoGameHook();
	void SaveTacticalGameHook(char *slot);
	void SaveGeoGameHook(char *slot);
	void LoadGameHook(char *slot);
	void SaveEquipmentLayout();
	extern int auto_flares;

	if(INI_READ_INT("Equipment Screen","Save Equipment",0))
	{
		InsertCall(0x41E44B, SaveEquipment); //41AE03,SaveEquipment);      //.text:00418C61 E8 5A 16 00 00           call    Tactical_EquipTeamDisplay
		InsertCall(0x44E682,InitNewGeoGameHook); //.text:0044A166 E8 D5 0A FF FF           call    InitNewGeoGame
		InsertCall(0x417911,SaveTacticalGameHook); //.text:00415B89 E8 92 04 00 00         call    SaveTacticalData
		InsertCall(0x44F937,SaveGeoGameHook); //.text:0044A7EC E8 CF 03 00 00              call    SaveGeoGameData
		InsertCall(0x44F6F5,LoadGameHook); //.text:0044A59A E8 11 14 00 00                 call    LoadGeographGame
		InsertCall(0x41D148,SaveEquipmentLayout);
		char patch[]={0xC3};
		PatchInPlace(0x41D14D,patch,1);
		if(INI_READ_INT("Equipment Screen","Auto Flares",0)) auto_flares = 1;
	}
#endif

	if(INI_READ_INT("Equipment Screen","Show Grenade State",0))
	{
		InsertCall(0x41B2F1,GrenadeState);  //.text:00418FEB 8B 14 8D 60 D6 49 00          mov     edx, StringsTable2_tactical[ecx*4]
		Nop(0x41B2F1+5,2);  
	}

	if(INI_READ_INT("Caps","Apply",0))
	{
		char jae[] = {0x73};

		
		unsigned char TU=INI_READ_INT("Caps","Time Units",80);			//.text:0044741D B8 50 00 00 00     mov eax, 80 ; TUs cap
		PatchInPlace(0x44B621,&TU,1); //0x44741D+1
		unsigned char health=INI_READ_INT("Caps","Health",60);			//.text:0044745C B8 3C 00 00 00     mov eax, 60 ; Health cap
		PatchInPlace(0x44B660,&health,1); //0x44745C+1
		unsigned char strength=INI_READ_INT("Caps","Strength",70);		//.text:0044749B B8 46 00 00 00		mov eax, 70 ; Strength cap
		PatchInPlace(0x44B69F,&strength,1); //0x44749B+1
		unsigned char energy=INI_READ_INT("Caps","Energy",100);			//.text:004474DA B8 64 00 00 00     mov eax, 100 ; Energy cap
		PatchInPlace(0x44B6DE,&energy,1); //4474DA+1
		unsigned char reactions=INI_READ_INT("Caps","Reactions",100);	//.text:0044751D 83 FA 64			cmp edx, 100 ; Reactions cap
		PatchInPlace(0x44B722,&reactions,1); //44751D+2
		PatchInPlace(0x44B723,jae,1); //447520							//.text:00447520 7D 44				jge short loc_447566
		unsigned char fa=INI_READ_INT("Caps","Firing Accuracy",120);	//.text:00447572 83 FA 78			cmp edx, 120 ; Firing accuracy cap
		PatchInPlace(0x44B777,&fa,1); //447572+2
		PatchInPlace(0x44B778,jae,1);  //447575							//.text:00447575 7D 44				jge short loc_4475BB
		unsigned char ma=INI_READ_INT("Caps","Melee Accuracy",120);		//.text:004475C7 83 FA 78			cmp edx, 120 ; Melee accuracy cap
		PatchInPlace(0x44B7CC,&ma,1); //4475C7+2
		PatchInPlace(0x44B7CD,jae,1); //4475CA							//.text:004475CA 7D 44				jge short loc_447610
		unsigned char ta=INI_READ_INT("Caps","Throwing Accuracy",120);  //.text:0044761C 83 FA 78			cmp edx, 120 ; Throwing accuracy cap
		PatchInPlace(0x44B821,&ta,1); //44761C+2
		PatchInPlace(0x44B822,jae,1); //44761F							//.text:0044761F 7D 44				jge short loc_447665 ; psi skill
		unsigned char ps=INI_READ_INT("Caps","Psi Skill",100);			//.text:00447665 80 7E 33 64        cmp byte ptr [esi+33h], 100  ; psi skill cap
		PatchInPlace(0x44B86B,&ps,1); //447665+3
	}

	extern void Shortcuts();

	//shortcuts
	if(INI_READ_INT("Battlescape Shortcuts","Apply",0) || INI_READ_INT("Geoscape Shortcuts","Apply",0) || (INI_READ_INT("Video","D3D",0) && INI_READ_INT("Video","D3D Windowed",0)))
	{
		Shortcuts();
	}

	if(INI_READ_INT("Mod","Auto sell",0))
	{
		AutoSell();
	}

if(INI_READ_INT("Mod","Single Stage Ship Missions",0))
	{
		Nop(0x450B3E,7);
		char stage1[]={0xEB};
		PatchInPlace(0x450B45,stage1,1);
		
	}
	
if(INI_READ_INT("Mod","Start with Alternate Tech Tree",0))
{
	if((INI_READ_INT("Mod","Start with Alternate Tech Tree",0)==1))
	{
		Nop(0x44863F,11);
	}
	if((INI_READ_INT("Mod","Start with Alternate Tech Tree",0)>1))
	{
	char vb[]={0x2B};								//make the vibroblade researchable when found:
	char vb1[]={1};
	char lance[]={0xB8};							//makes the thermic lance require Calcinite corpse research instead of Gillman
	PatchInPlace(0x47A826,vb,1);
	PatchInPlace(0x47A832,vb1,1);
	PatchInPlace(0x47A836,vb1,1);
	PatchInPlace(0x448AF7,lance,1); 
	Nop(0x448ADC,16);								//removes unneeded byte in regards to prerequisites for vibroblade research
	if((INI_READ_INT("Mod","Start with Alternate Tech Tree",0)>2))
		{	
			char ap[]={0x58};						//make aqua plastic researchable when found:
			char bp[]={1};
			PatchInPlace(0x47A4A0,ap,1);	
			PatchInPlace(0x47A4AC,bp,1);	
			PatchInPlace(0x47A4B0,bp,1);	
			Nop(0x44863F,45);						//Remove bytes for ion armor since replaced by my tree
			InsertCall(0x44875D,AltResearchTree);	//Plastic Armor requires Deep One autopsy//Ion Armor requires Lobsterman autopsy
			Nop(0x448762,93);						//remove the unnecessary bytes
			char ion[]={0x43,05,05,02};
			char magion[]={0x43,05,0x10,02};		//need two lobstermen corpses to make ion and magnetic ion armor
			PatchInPlace(0x47AC80,ion,4);
			PatchInPlace(0x47AC92,magion,4);
		}
	}	
}

if (INI_READ_INT("Mod","Improved Gauss Tank",0))
	{
		char prereq[]={0xA8};
		PatchInPlace(0x448990,prereq,1);			//makes aqua plastics a prerequisite for Tank/Gauss
		InsertCall(0x456E01, TankStats);
		Nop(0x456E06,85);						//Removes the bytes that TankStat() replaces.
		char prodstat[]={0x58,0xFF,0xFF,0x5};
		PatchInPlace(0x47AAE0,prodstat,4);
		InsertCall(0x465233,ImpGaussUP1);
		InsertCall(0x46526B,ImpGaussUP2);
		InsertCall(0x4652A5,ImpGaussUP3);
		InsertCall(0x4652DF,ImpGaussUP4);
		InsertCall(0x465316,ImpGaussUP5);
	}

if (INI_READ_INT("Mod","Improved Detector",0))
	{
		char max[]={0x28};
		char min[]={0xD8};
		PatchInPlace(0x40B3DA,min,1);
		PatchInPlace(0x40B3E7,min,1);
		PatchInPlace(0x40B3E0,max,1);
		PatchInPlace(0x40B3ED,max,1);
		InsertCall(0x40B3F5,ImprovedDetector);
		Nop(0x40B3FA,88);
	}

if(INI_READ_INT("Mod","Improve Rearm Rate of Ajax",0))
	{
		char ajax[]={2};
		PatchInPlace(0x47A216,ajax,1);
	}

if(INI_READ_INT("Mod","Different Site Races",0))
	{
		InsertCall(0x460846,StartColonyHook);
		InsertJmp(0x4527B5,BaseRaceMod);
		Nop(0x4527BA,4);
		InsertJmp(0x452D26,Base2RaceMod);
		Nop(0x452D2B,4);
		InsertJmp(0x4552C4,altartifactrace);
		if(INI_READ_INT("Bug Fix","Alternate Colony Weapons Loadout",1)==1)
		{
			char commander[]={0x22,0x23,0x2C,0x00,0x00,0x22,0x23,0x2C,0x00,0x00,0x22,0x23,0x2C};
			PatchInPlace(0x47DEAE,commander,13);
			char leader[]={0x22,0x23,0x2C,0x00,0x00,0x22,0x23,0x2C,0x00,0x00,0x22,0x23,0x2C,0x2C};
			PatchInPlace(0x47DEC3,leader,14);
			char soldier[]={0x22,0x23,0x2C,0x00,0x00};
			PatchInPlace(0x47DF21,soldier,5);
		}
	}

if(INI_READ_INT("Mod","Ablative Armor",0))
	{
		InsertJmp(0x40E910,ArmorMod1);
		Nop(0x40E915,4);
		InsertJmp(0x40E939,ArmorMod2);
	}

if(INI_READ_INT("Mod","Know Thy Enemy",0))
	{
		InsertJmp(0x40E964, DamageMod);
		InsertCall(0x40EAAF, StunMod);
		Nop(0x40EAB4,6);
	}

if(INI_READ_INT("Mod","Smaller USO Battle Maps",0))
	{
		char mapsize[]={4};
		PatchInPlace(0x451D72,mapsize,1);
	}

if(INI_READ_INT("Mod","Smaller Colony Size",0))
	{
		char colony2xy[]={4};
		char colony2a[]={0x10};
		char colony2b[]={2};
		char colony2b1[]={0x66,0x8B,0xF0};
		char colony2b2[]={0xB0};
		char colony2b3[]={0x70};
		char colony2b4[]={0x71};
		char colony2c[]={0xF};
		char colony2c1[]={0x66,0x8B,0xE8,};
		char colony2c2[]={0xA8};
		PatchInPlace(0x452916,colony2xy,1);
		InsertCall(0x452950,altcolony2);
		Nop(0x452955,2);
		PatchInPlace(0x45295D,colony2a,1);
		PatchInPlace(0x45296E,colony2b,1);
		PatchInPlace(0x452975,colony2b,1);
		PatchInPlace(0x452976,colony2b1,3);
		PatchInPlace(0x452980,colony2b2,1);
		PatchInPlace(0x452999,colony2b3,1);
		PatchInPlace(0x4529A0,colony2b4,1);
		PatchInPlace(0x4529A6,colony2c,1);
		PatchInPlace(0x4529CB,colony2b,1);
		PatchInPlace(0x4529D2,colony2b,1);
		PatchInPlace(0x4529D3,colony2c1,3);
		PatchInPlace(0x4529DD,colony2c2,1);
		PatchInPlace(0x4529F6,colony2b3,1);
		PatchInPlace(0x4529FE,colony2b4,1);
		PatchInPlace(0x452A2B,colony2b3,1);
		PatchInPlace(0x452A32,colony2b4,1);
		PatchInPlace(0x452A40,colony2a,1);
	}

if(INI_READ_INT("Mod","Smaller Stun Blast",0))
	{
		InsertJmp(0x40BD56,StunBlastMod);
	}

if(INI_READ_INT("Mod","Modified Loadouts for Aquatoid",0))
	{
		InsertJmp(0x457FF0,ModLoadout);
	}

if(INI_READ_INT("Mod","Hot Grenades",0)) 
	{
		//Nop(0x41E095,6);  this just disabled checks to see if grenade was held. Modern Grenades have safety catch to prevent 
		// this kind of accident. Lets make grenades exlode when thrown to prevent the passing of armed grenades.  One could still
		//set a live grenade down from inventory but necessary to simulate handing the grenade to another.
		InsertJmp(0x42100D,HotGrenade1);
		Nop(0x410151,1);                //removes the 'pop edi' so we can use edi in HotGrenade2 w/o problems
		InsertJmp(0x4101DD,HotGrenade2);
		char patch[]={0x90,0x90,0x90,0x90,0x5F};  //pop  edi
		PatchInPlace(0x4101E2,patch,5);
		InsertJmp(0x405512,HotGrenade3);
		char time1[]={1};
		PatchInPlace(0x40549F,time1,1);
	}

if(INI_READ_INT("Mod","EU2012 Item Rules",0))
	{
		InsertJmp(0x40EFD9,ItemDest);
		char clearedx[]={0x33,0xD2,0x90}; 
		                //33 D2          xor    edx,edx
		                //   90          nop
		PatchInPlace(0x40EFDE,clearedx,3);
		InsertJmp(0x42E008,BurnItems);
		Nop(0x42E00D,11);
		Nop(0x4226E7,5); //Units will not drop weapons on Panic
	}

if(INI_READ_INT("Mod","Base Defense Prep",0))
	{
		InsertCall(0x4603C1,BaseDefenseHook);
		Nop(0x452463,60);
		char patch[]={0x18};
		PatchInPlace(0x4524A1,patch,1);
		Nop(0x4524A2,107);
		Nop(0x452510,10); 
		InsertJmp(0x456C8A,BaseDefensePrep);
		Nop(0x4575F3,16);
	}

if(INI_READ_INT("Mod","Deep Colonies",0))
	{
		InsertJmp(0x4605C5,DeepColony);
	
	}
	//--NOT TRANSLATED--  IS THERE A GREAT DEMAND FOR THESE MODS? NO NEED TO FIX WHAT ISN'T USED. WAIT AND SEE.. 
	/*
	if(INI_READ_INT("Mod","No Auto Wake Up",0))
	{
		//.text:00413560 E8 EB 00 00 00                call    WakeUnconsciousUnitUp
		Nop(0x413560,5);
	}
	*/	
/*
	if(INI_READ_INT("Mod","Assign All Personnel",0))
	{
	//		.text:00434D47 8A 04 0A                      mov     al, [edx+ecx]
	//		.text:00434D4A 84 C0                         test    al, al
		//InsertCall(0x438AE3,AssignAllScientists1);
		//Nop(0x438AE3+5,38);
		InsertCall(0x438B25,AssignAllScientists2); //0x434D47
		Nop(0x438B25+5,33);

	//.text:00436311 66 8B 84 71 8C 00 00 00       mov     ax, [ecx+esi*2+0ACh]
	//.text:00436319 66 3B C2                      cmp     ax, dx

		InsertCall(0x43A183,AssignAllEngineers);
		Nop(0x43A183+5,44);  //0x436311
	}
*/

	/*

	if(INI_READ_INT("Mod","Retaliate Against Ground Assault",0)) 
	{
		InsertCall(0x44720A,RetaliationAfterGroundAssault);
	}
	*/
/*	
	if(int capacity = INI_READ_INT("Mod","General Store Capacity",0))
	{
		unsigned short cap = capacity * 10;
//		.text:00439C85 66 81 C5 F4 01                add     bp, 500
		if((unsigned int)cap*35>65535)
		{
			cap = 65535/35;
		}
		PatchInPlace(0x439C85+3,&cap,2);
//.text:00439E60 0F 8D E3 00 00 00             jge     loc_439F49
		char jae[] = {0x83};
		PatchInPlace(0x439E60+1,&jae,1);
//.text:00439E9D 66 3D F4 01                   cmp     ax, 1F4h
		PatchInPlace(0x439E9D+2,&cap,2);
//.text:0045639F 7E 14                         jle     short loc_4563B5
		char jbe[] = {0x76};
		PatchInPlace(0x45639F,&jbe,1);
//.text:004366A5 7C 11                         jl      short loc_4366B8
		char jb[] = {0x72};
		PatchInPlace(0x4366A5,&jb,1);
//.text:00438BAF 7C 17                         jl      short loc_438BC8
		PatchInPlace(0x438BAF,&jb,1);
	}

	if(INI_READ_INT("Craft Ready Message","Apply",0))
	{
//		.text:0044287F 66 FF 0D 60 AA 49 00          dec     geo_num_rearming_crafts
		InsertCall(0x44287F,ShowCraftReadyBox);
		Nop(0x44287F+5,2);
	}

	if(INI_READ_INT("Mod","Funding Council Income Only",0))
	{
//.text:00448E22 A1 6C 3F 4A 00                mov     eax, carretPosition
//.text:00448E27 8B 4F 0A                      mov     ecx, [edi+0Ah]
		InsertCall(0x448E22,IncomeOnlyItemPrice);
		Nop(0x448E27,3);
		InsertCall(0x4489AE,IncomeOnlyItemPrice2);
		Nop(0x4489AE+5);
		InsertCall(0x44892B,IncomeOnlyItemPrice3);
		Nop(0x44892B+5);
//.text:00448E27 8B 4F 0A                      mov     ecx, [edi+0Ah]
		char patch[]={0x33, 0xC9, 0x90};
		PatchInPlace(0x448E27,patch,3);

//.text:004489B4 29 15 38 A8 49 00             sub     dword_49A838, edx
		Nop(0x4489B4,6);
//.text:00448931 03 C2                         add     eax, edx
		Nop(0x448931,2);
	}
*/

/*
	if(INI_READ_INT("Mod","Limited Military",0))
	{
//		.text:0043B133 BE 08 00 00 00                mov     esi, 8
		unsigned char numSoldiers=INI_READ_INT("Mod","Limited Military",0);
		PatchInPlace(0x43B134,&numSoldiers,1);

//		.text:00436CE8 B9 62 07 47 00                mov     ecx, offset purchaseInfo.canBeBought
		InsertCall(0x436CE8,DisableSoldierPurchase);

//Reduce wage
//		.text:0043BFD7 C1 E0 05                      shl     eax, 5
		unsigned char shift[]={2};
		PatchInPlace(0x43BFD7+2,shift,1);
	}
*/
/*
	if(INI_READ_INT("Mod","No Funkers",0))
	{
		/*
		.text:00449262 E8 99 02 00 00                call    GetSoldierScoreForPromotion
		.text:0044930B E8 F0 01 00 00                call    GetSoldierScoreForPromotion
		.text:004493BF E8 3C 01 00 00                call    GetSoldierScoreForPromotion
		.text:00449473 E8 88 00 00 00                call    GetSoldierScoreForPromotion
		/
		InsertCall(0x449262,GetScoreForPromotion);
		InsertCall(0x44930B,GetScoreForPromotion);
		InsertCall(0x4493BF,GetScoreForPromotion);
		InsertCall(0x449473,GetScoreForPromotion);

	}

	if(INI_READ_INT("Mod","Bloodthirst",0))
	{
		//	0f b7 c2	 movzx	 eax, dx
		char patch[]={0x0f,0xb7,0xc2};
		PatchInPlace(0x4495BD,patch,3);
		Nop(0x4495BD+3,7);
	}
*/

//fog of war
	/*
	if(0)
	{
		//.text:0042683E E8 0D A1 00 00                call    sub_430950

		InsertCall(0x42683E,Fog);
		InsertCall(0x4269B2,Fog);
		InsertCall(0x401014,UpdateFogMap);
		InsertCall(0x42DD87,HookSeeMap);
//		InsertCall(0x42A703,FixSeeMap);
//		Nop(0x42A703+5);
	}
	*/

	//realtime terrain
/*	if(0)
	{
		InsertCall(0x420D61, UpdateTerrain);
	}
*/
/*
	//Stun
	if(INI_READ_INT("Mod","Stun Fest",0))
	{
		extern int stunActivated;
		stunActivated=1;

		ModStun();
	}

	int fast=INI_READ_INT("Mod","Fast Base Defenses",0);
	if(fast)
	{
		Nop(0x4484C9,5);
		Nop(0x4484ED,5);
		Nop(0x44852E,5);
		Nop(0x4485F0,5);
		Nop(0x448629,5);
		Nop(0x448674,5);
		Nop(0x4486CE,5);
		Nop(0x448773,5);
		Nop(0x448788,5);
		Nop(0x4487A8,5);

		if(fast==2) //remove the button press
		{
			Nop(0x4487E0,2);
		}
	}

	//Create some bases from the begining
	if(INI_READ_INT("Mod","Initial Alien Bases",0))
	{
		//.text:004513A8 call    CreateXComBase
		InsertCall(0x4513A8,CreateInitialAlienBases);
	}

	if(INI_READ_INT("Mod","Disable Base Defenses",0))
	{
		//.text:004578FC E8 8F 0A FF FF                call    ActivateBaseDefensesAgainstAlienShip
		char patch[]={0x33,0xC0,0x90,0x90,0x90}; //xor eax,eax
		PatchInPlace(0x4578FC,patch,5);
	}

	if(INI_READ_INT("Mod","Surrender Defence Missions",0))
	{
//		.text:00457913 E8 A8 2D 00 00                call    AreThereSoldiersInBase
		char patch[]={0x33,0xC0}; //xor eax,eax
		PatchInPlace(0x457913,patch,2);
		Nop(0x457913+2,3);
	}
*/
/*
	//Base build stacking
	if(INI_READ_INT("Mod","Base Building Stacking",0))
	{
		ModBaseBuildingStacking();
	}
*/

/////////////////Bug Fixes/////////////////////

	if (INI_READ_INT("Bug Fix","Tech Tree Impasses",1))
	{
		char subcon[]={0x01};				//Makes sub construction available for research when one is found:
		PatchInPlace(0x47A428,subcon,1);
		PatchInPlace(0x47A42E,subcon,1); 
		if (INI_READ_INT("Mod","Start with Alternate Tech Tree",0)==0)
		{ 
			Nop(0x448788,54);
		}
		
		char Subjmp[]={0xEB};  
		PatchInPlace(0x448C62,Subjmp,1);	//Jmps to next section of subroutine
		Nop(0x448C64,9);					//removes the reference to MC Reader
		char mc[]={0x01};					//makes MC reader available for research when one is found:
		PatchInPlace(0x47A3E6,mc,1);
		PatchInPlace(0x47A3EA,mc,1); 
	}
	
	if(INI_READ_INT("Bug Fix","PWT Production Fix",1))
	{
		char PWT[]={0x58,0xFF};
		char PWT2[]={1,0};
		PatchInPlace(0x47AA98,PWT,2);
		PatchInPlace(0x47AA9B,PWT2,2);
	}

	if(INI_READ_INT("Bug Fix","Gauss Tank Ammo Fix",1))
	{
		InsertCall(0x45EC1C,GaussTankAmmo);
		char gauss1[]={3};
		PatchInPlace(0x45EC18,gauss1,1);
		char gauss2[]={0x74, 0x1E};
		PatchInPlace(0x45EC1A,gauss2,2);
		char gauss3[]={0x66,0x3D,00,00,0x74,0x13};
		PatchInPlace(0x45EC21,gauss3,6);
		Nop(0x45EC27,14);
		InsertCall(0x44B55E,GaussTankAmmo2);
		Nop(0x44B563,36);
		InsertCall(0x44E25C,GaussTankAmmo3);
		Nop(0x44E261,38);
		InsertCall(0x44E043,GaussTankAmmo3);
		Nop(0x44E048,38);
		if (INI_READ_INT("Mod", "Improved Gauss Tank",0)==0)
		{
		Nop(0x44898E,9);											//remove the flying sub req to get the gauss tank.
		}
		if (INI_READ_INT("Bug Fix","Gauss Tank Turrent Stats Fix",1)!=0)
		{
			char gauss4[]={0x5A,0,0x50,0,0x21,0,0x4B,0,0x42,0,0x64}; //lower dam to 90 but add autofire and raise aim fire to 100% base
			PatchInPlace(0x47798C,gauss4,11);
			char gauss5[]={0x5A};
			PatchInPlace(0x48B576,gauss5,1);						 //Alters the ufopaedia entry to reflect damage
		}
	}
	
	if (INI_READ_INT("Bug Fix","Displacer Sonic Cannon Fix",1))
	{
		char damage[]={0x82};
		PatchInPlace(0x4779A0,damage,1);	//damage is now the 5 less than sonic cannon
		PatchInPlace(0x48B57E,damage,1);	//alter ufopaedia entry to reflect change
	}
		
//Funky fire
	if(INI_READ_INT("Bug Fix","Funky Fire",1))
	{
		Nop(0x40DEE4,5);  //.text:0040D51C E8 7F C7 01 00                call    ApplyFireAndStunDamage
		Nop(0x40FAEE,5);  //.text:0040F092 E8 09 AC 01 00                call    ApplyFireAndStunDamage
		Nop(0x411337,5);  //.text:0041074E E8 4D 95 01 00                call    ApplyFireAndStunDamage
		Nop(0x4116DB,5);  //.text:00410ADB E8 C0 91 01 00                call    ApplyFireAndStunDamage
		InsertJmp(0x414461,FireDamage);
		char fireDamage[]={10};
		PatchInPlace(0x42DCD9,fireDamage,1);   //.text:00429CD8 6A 05    push    5     ; rndMax
	}
		
	if(INI_READ_INT("Bug Fix","Corpses Don't Teleport",1))
	{
		InsertCall(0x40D7F2, PrepCorpse);
	}

	if(INI_READ_INT("Bug Fix","Artifacts collected on Abort fix",1))
	{
		InsertCall(0x416438,AbortClipFix);
		Nop(0x416438+5,2);
	}

	if(INI_READ_INT("Bug Fix","Base Facility Dismantle-Construction Crash",1))
	{
		BaseFacilityDismantleConstructionCrash();
	}

	if(INI_READ_INT("Bug Fix","Sensor Stacking",1))
	{
		InsertJmp(0x43DC10,FixSensorStacking);//0x439D10
	}

	if(INI_READ_INT("Bug Fix","Door Jam",1))
	{
		InsertCall(0x41E745,FixDoorJam);  //0x41B97B
	}

	if(INI_READ_INT("Bug Fix","Hostile Civilians",1))
	{
		//.text:00413203 84 C9                         test    cl, cl
		//.text:00413205 0F 94 C2                      setz    dl
		InsertCall(0x414506,GetOwner);  
	}

	//Zrbite ships
	if(INI_READ_INT("Bug Fix","Zrbite-fueled Craft Bug",1))
	{
		InsertCall(0x445FEF,ZrbiteShipFix); 
	}

	//Force the fix if using Crafts always ready to prevent transfered crafts from being stuck
	if(INI_READ_INT("Bug Fix","Transfered Crafts Refueled",1) || INI_READ_INT("Mod","Crafts Always Ready",0))
	{
		Nop(0x445318,7);   //		044151F 66 C7 44 10 18 00 00    
	}

	if(INI_READ_INT("Bug Fix","Proximity Grenades",1)) 
	{
		InsertCall(0x42E7A9,FixProximityMines); 
	}

	if(INI_READ_INT("Bug Fix","Proximity Grenades Experience",1))
	{
		InsertCall(0x421259,FixProximityMinesExperience); 
	}

	if(INI_READ_INT("Bug Fix","BioDrone Melee Attack Fix",1))
	{
		char melee[]={0x5A};
		PatchInPlace(0x48B6E5,melee,1);
	}

	if(INI_READ_INT("Bug Fix","Fix Tentacult",1))
	{
		char strength[]={0x1E};
		PatchInPlace(0x48B6BC,strength,1);
		InsertJmp(0x403AFC,TentacultIgnoreTank);
		Nop(0x403B01,12);
		InsertJmp(0x40697D,TentacultVictimYell);
		//Nop(0x406982,8);
	}
	
	if(INI_READ_INT("Bug Fix","Fix Lobstermen Strength",1))
	{
		char strength[]={0x64};
		PatchInPlace(0x48B8B7,strength,1);
		PatchInPlace(0x48B8DE,strength,1);
		PatchInPlace(0x48B904,strength,1);
		PatchInPlace(0x48B92C,strength,1);
		PatchInPlace(0x48B953,strength,1);
	}


	if(INI_READ_INT("Bug Fix","Hallucinoid Range Attack Fix",1))
	{
		InsertCall(0x457EC9, FixHallucinoidStun);
		Nop(0x457ECE,28);
		if (INI_READ_INT("Bug Fix","Modify Hallucinoid Range Attack",1))
		{
			char stun1[]={5,0,0x2A,0,0x78}; //dam type=stun, ammo type=thermal shock bomb
			PatchInPlace(0x4779C4,stun1,5);
			char stun2[]={0x21}; //TU cost 33%
			PatchInPlace(0x4779CC,stun2,1);
		}
	}

	if(INI_READ_INT("Bug Fix","FixSounds",1))
	{
		char popfix[]={0x0A};
		PatchInPlace(0x467009,popfix,1);
		char zombie[]={0x00};
		PatchInPlace(0x4775D4,zombie,1);
		char debrief[]={0x7F};
		PatchInPlace(0x44C561,debrief,1);
		char zomattack[]={0xCA};
		PatchInPlace(0x4069C0,zomattack,1);
	}
	
	if(INI_READ_INT("Bug Fix","No Underwater Weapons Fire on Land",1))
	{
		if(INI_READ_INT("Mod","Use All Items On Land",0)==0) //Don't apply if this is Enabled
		{
			InsertCall(0x410853,CheckTankForDepth);
			char jz[]={0x84};
			PatchInPlace(0x4104FF,jz,1);
			char HEammo[]={2};
			PatchInPlace(0x410B28,HEammo,1);
			PatchInPlace(0x410B2A,jz,1);
			InsertCall(0x41091E,CheckForDepth);
			Nop(0x410923,16);
		}
	}

	if(INI_READ_INT("Bug Fix","Personnel Overflow",1))
	{
		InsertCall(0x4453EC,FixScientistsEngineersOverflow); 
		Nop(0x4453F1); 
		InsertCall(0x44541A,FixScientistsEngineersOverflow); 
		Nop(0x44541F);  
	}

	if(INI_READ_INT("Bug Fix","Deep One is not Celatid",1))
	{
		Nop(0x403197,65);
		Nop(0x4032F1,11);
		Nop(0x40349D,14);
		Nop(0x40DB82,6);
		char deep2[]={0xE9, 0xED};
		PatchInPlace(0x40DB88,deep2,2);
		Nop(0x40DD6D,12);
		Nop(0x40E066,14);
		char wpn[]={0x5};
		PatchInPlace(0x42EA1B,wpn,1);
		InsertCall(0x457EEC,FixDeepOneGun);
		Nop(0x457EEC+5,3);
		//Nop(0x41085E,9); //enables snap shot
		Nop(0x4124FB,5); //disables the special attack efx routine for celatid spit
		if(INI_READ_INT("Bug Fix","Modify Deep One Gun Stats",1))
		{
			char gunstat[]={7,0,0x24,0,0x3C,0,0,0,0,0,0x44,0,0x1B,0,0,0,0}; // section changes dam type to 7, damage to 60,removes snap fire stats, adjusts autofire, removes aim stats
			if(INI_READ_INT("Mod","Ranged Based Accuracy",0)==1) 
				{
					char gunstat[]={7,0,0x24,0,0x3C,0,0,0,0,0,0x5A,0,0x1B,0,0,0,0};
				}
			PatchInPlace(0x4779EC,gunstat,17);
		}
	}

	if(INI_READ_INT("Bug Fix","Biodrone is not Silacoid",1))
	{
		Nop(0x40290C,121);
	}

	if(INI_READ_INT("Video","Slow Battlescape Animation Speed",0))
	{
		unsigned char speed=INI_READ_INT("Video","Battlescape Delay",10);
		if (speed<6) speed=6;
		PatchInPlace(0x42E83C,&speed,1);
	}

	if(INI_READ_INT("Video","Slow Geoscape Clock",1))
	{
		InsertJmp(0x444CC4,SlowGeoClock1);
		//char sec[]={1};
		//PatchInPlace(0x444B47,sec,1);
		char min[]={0x2}; 
		char min2[]={0x1}; 
		PatchInPlace(0x444AF2,min,1);
		PatchInPlace(0x444FEB,min2,1);
		char fivemin[]={0xC};
		char fivemin2[]={0xA};
		PatchInPlace(0x444AFD,fivemin,1);
		PatchInPlace(0x444FF0,fivemin2,1);
		char thirmin[]={0x3C,0};
		PatchInPlace(0x444B08,thirmin,2);
		PatchInPlace(0x444FD7,thirmin,2);
		char hour[]={0x78,0};
		PatchInPlace(0x444B13,hour,2);
		PatchInPlace(0x445014,hour,2);
		char day[]={0xD0,2};
		PatchInPlace(0x444B1E,day,2);
		PatchInPlace(0x44501B,day,2);
	}

	if(INI_READ_INT("Bug Fix", "Unconscious Unit MC fix",1))
	{
		InsertCall(0x40F27A, KoMCfix);
	}

	if(INI_READ_INT("Bug Fix","EOB fix",1))
	{
		Nop(0x415DE9,4);
		InsertCall(0x40D804,EOB_PreCheck);
		InsertCall(0x4143FB,EOB_PreCheck);
		InsertCall(0x41461B,EOB_PreCheck);
		InsertCall(0x41496E,EOB_PreCheck);
		InsertCall(0x419A8A,AbortPreEOB);
		InsertCall(0x419727,UnitCountFix);
		Nop(0x41972C, 4);
		InsertCall(0x4160F5,KOUnitFix);
		Nop(0x4160FA,59);
		Nop(0x4160E3,18);
	}
	
	if(INI_READ_INT("Bug Fix","Ship Attack Randomize Bug Fix",1))
	{
		char randseed[]={0x0A};
		PatchInPlace(0x453DD8,randseed,1);
		InsertCall(0x453E03, RandomizeShippingLineType);
		Nop(0x453E10,2);
		Nop(0x453E14,3);
	}

	if(INI_READ_INT("Bug Fix","Fire Fix",1))
	{
		InsertJmp(0x42DDB6,FireFix);
		Nop(0x42DDBB,129);
	}
	
	if(INI_READ_INT("Bug Fix","Manufacture Rate Limit Fix",1))
	{
		InsertCall(0x43A13B,MFGlimitRateFix);
		Nop(0x43A140,34);
	}
	
	if(INI_READ_INT("Bug Fix","Fix Particle Detector Animation",1))
	{
		char delay[]={0x15};
		PatchInPlace(0x40B490,delay,1);
	}

	if(INI_READ_INT("Bug Fix","Clip Weight Fix",1))
	{
		InsertCall(0x41C025, ClipFixHook1);
		Nop(0x41C02A,13);
		InsertCall(0x41BE3B, ClipFixHook1);
		Nop(0x41BE40,12);
		InsertCall(0x41BE51, ClipFixHook2);
		Nop(0x41BE56,5);
		InsertCall(0x41C039, ClipFixHook3);
		Nop(0x41C03E,8);
		InsertCall(0x422D8D, ClipFixHook4);
		Nop(0x422D92,1);
		InsertCall(0x40FFB7, ClipFixHook5);
		Nop(0x40FFBC,5);
		InsertCall(0x41ADBD, FixClipWeight);
	}

	if(INI_READ_INT("Bug Fix","Gauss Cannon Rearm Fix",1))
	{
		char max[]={0x64};
		PatchInPlace(0x47A25C,max,1);
		char Greplace[]={0x32};
		PatchInPlace(0x47A25E,Greplace,1);
	}
	
	if(INI_READ_INT("Bug Fix","PWT Ammo Manufacture Fix",1))
	{
		char CraftCost[]={0x40,0x1F};
		PatchInPlace(0x47AAC6,CraftCost,2);
		char CraftMake[]={0xDC,0x00,0x19,0x00,0x3C,0x58,0xFF,4,1};
		PatchInPlace(0x47AACA,CraftMake,9);
		char CraftSell[]={0x84,0x42};
		PatchInPlace(0x47B006,CraftSell,2);
		char SWSCost[]={0x50,0x46};
		PatchInPlace(0x47AB0E,SWSCost,2);
		char SWSMake[]={0x0F,0x00,0x3C,0x58,0xFF,3,1};
		PatchInPlace(0x47AB14,SWSMake,7);
		char SWSSell[]={0xA8,0x93};
		PatchInPlace(0x47B3EE,SWSSell,2);
		char AmmoCost[]={0x60,0x6D};
		PatchInPlace(0x47AC0A,AmmoCost,2);
		char AmmoMake[]={0x58,0x02,0x03,0x00,0x3C,0x58,0xFF,5,1};
		PatchInPlace(0x47AC0E,AmmoMake,9);
		char AmmoSell[]={0xD0,0xE8};
		PatchInPlace(0x47B0CE,AmmoSell,2);
	}

	if(INI_READ_INT("Bug Fix","Plastic Armor Modifier Fix",1))
	{
		char personal[]={0x7E};
		PatchInPlace(0x457126,personal,1);
	}

	if(INI_READ_INT("Bug Fix","Alien Attacks Base Location Fix",1))
	{
		char patch[]={0xC0,0x85,0x4D};
		PatchInPlace(0x4033A8,patch,3);
		PatchInPlace(0x4033ED,patch,3);
	}

	if(INI_READ_INT("Bug Fix","Large Unit MC Fix",1))
	{
		InsertJmp(0x422150, LargeUnitMCFix);
		Nop(0x422155,45);
	}

	if(INI_READ_INT("Bug Fix","Large Unit Explosion Fix",1))
	{
		InsertJmp(0x40D958,LargeUnitExplosionFix);
	}

	if(INI_READ_INT("Bug Fix", "Zombie Fix",1))
	{
		InsertJmp(0x409867,ZombieMCFix);
		char patch[]={0x33, 0xC0};   //xor  ecx, ecx
		PatchInPlace(0x40986C,patch,2);
		Nop(0x40986E,2);
	}

if (INI_READ_INT("Bug Fix","No Freebies for Tanks",1))
	{
		InsertJmp(0x456F4B,BaseTankAmmoFix);
		Nop(0x456F2E,3);                 //removes cmp   bx, dx
		Nop(0x456EDC,4);                 //removes loading soldier.dat ref into ecx
        char patch[]={0xB1,0x14,0x90};   //mov   cl, 14h
		PatchInPlace(0x456EE3,patch,3);
		Nop(0x456F50,36);                //removes rest of the section replaced by the fix.
	}

if(INI_READ_INT("Bug Fix","Tank Ammo Storage Fix",1))
	{
		char patch[]={0};
		PatchInPlace(0x47D5A9,patch,1);
		PatchInPlace(0x47D5AC,patch,1);
	}

if (INI_READ_INT("Bug Fix","Recover Clips Fix",1))
	{
		InsertJmp(0x44C080,RecoverClipFix);
		Nop(0x44C085,19);                   //Removes old code that fix replaces
	}

if (INI_READ_INT("Bug Fix","Bezerk Terrorist Crash Fix",1))
	{
		InsertJmp(0x422431, BezerkCrashFix);
	}

if (INI_READ_INT("Bug Fix","Alien Melee Attack Fix",1))
	{
		InsertJmp(0x4015DA,SetMeleeAttackFix);
		Nop(0x4015DF,48);
		Nop(0x404210,12);  //In Alien choose weapon subroutine, removes the exclusion of melee weapons.
		char patch[]={0x33,0xC0,0x90,0x90,0x90,0x90,0x90};
		PatchInPlace(0x40160F,patch,7);
	}

	//current code creates occasional error. However, the problem is there are too few spawn points per node especially on higher difficulties.
	//Reducing number of nodes would keep all aliens from spawning or spawn in entry areas.
/*	if(INI_READ_INT("Mod","alternate artifact size",0))  
	{
		InsertCall(0x454E8B,altartifact2a);
		Nop(0x454E90,7);
		char artifact1[]={8}; //0C  
		PatchInPlace(0x454EC,Eartifact1,1);
		InsertCall(0x454EDE,altartifact2b);
		Nop(0x454EE3,51);
		char artifact2[]={7}; //0B 
		PatchInPlace(0x454F17,artifact2,1);
		char artifact3[]={0x6F};
		char artifact4[]={0x70};
		char artifact5[]={1};
		PatchInPlace(0x454F36,artifact5,1);
		//InsertCall(0x454F3F,altartifact2c);
		Nop(0x454F3F,116); //454F44,18);
		//PatchInPlace(0x454F6B,artifact3,1);
		//PatchInPlace(0x454F73,artifact4,1);
		//PatchInPlace(0x454FA0,artifact3,1);
		//PatchInPlace(0x454FA7,artifact4,1);
		PatchInPlace(0x454FB9,artifact1,1);
	}
*/

//	if(INI_READ_INT("Bug Fix","Low Fuel After Mission",0))
//	{
//.text:00457D6B 0C 02                         or      al, 2
//		Nop(0x460862,2);  //tftd offset done
//	}

	//////////////////Hacks////////////////////
/*
	 Drawing FPS subsection remove in TFTD	{InsertCall(0x44102F,DrawFPSGeo)}
*/
//#ifdef NDEBUG
	if(INI_READ_INT("Hack","No Score Game Over",0)) 
//#endif
	{
		HackNoScoreGameOver();
	}

	if(INI_READ_INT("Hack","No Alien Psi",0)) 
	{
		HackNoAlienPsi();
	}

	if(INI_READ_INT("Hack","Directly Use Alien Weapons",0)) 
	{
		HackDirectlyUseAlienWeapons();
	}

	if(INI_READ_INT("Hack","Recover All Clips",0))
	{
		 HackRecoverAllClips();
	}

	if(INI_READ_INT("Hack","Show All Locations",0))
	{
		HackShowAllLocations();
	}

	//InsertJmp(0x425455,HackDebugFlagsCheck);

}
